
$Rows  = 0;

$RawSize = 204800;		# Maximum size of data to read in

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub currval_Graffiti
{
# To read the current sequence value
my($dbh)  = @_;
my($sql) = "SELECT gwgenius.currval FROM dual";
my($count);

    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

   ($count) = getNextRow_Graffiti($sth);

    return (0, "", $count);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub nextval_Graffiti
{
my($dbh)  = @_;
my($sql) = "SELECT gwgenius.nextval FROM dual";
my($count);

    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

   ($count) = getNextRow_Graffiti($sth);

    return (0, "", $count);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub create_Graffiti
{
my($dbh, $table)  = @_;
my($CREATE) = "CREATE TABLE %s ( UniqKey NUMBER, UserID CHAR(22), ImgSize CHAR(1), Title VARCHAR(8), Descriptor VARCHAR(16), Cmt VARCHAR2(128), DLCount NUMBER, RankTotal NUMBER, RankCnt NUMBER, CurRank NUMBER, Pending CHAR(1), AdminID VARCHAR(22), DateC INT, DateA INT, VMS LONGBLOB )";
my($sql);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

    $sql = sprintf($CREATE, $table);

    $dbh->do($sql);
    return($DBI::err, $DBI::errstr) if $DBI::err;

	# Initialize UniqKey
    initializeLastRowNumber($dbh, $table);
    return($DBI::err, $DBI::errstr) if $DBI::err;

    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub delete_Graffiti
{
my($dbh, $table)  = @_;
my($DROP) = "DROP TABLE %s";
my($sql);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

    $sql = sprintf($DROP, $table);

    $dbh->do($sql);
    return($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub selectAllRows_Graffiti
{
my($dbh, $table)  = @_;
my($LIST) = "SELECT * FROM %s ORDER BY DateC";
my($sql);
my($sth);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

    $sql = sprintf($LIST, $table);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;


#    $sth->fetchrow_array; # Skip first entry

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub initializeLastRowNumber
{
	my($dbh, $table)  = @_;

	# Build a blank record to just store the Unique Number
	my($errn, $errs) = insertRow_Graffiti($dbh, $table, '', '', '', '', '', 0, 0, 0, 0.0, 'N', 0, 0, '');
	return($errn, $errs) if $errn;

    return($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub incrementLastRowNumber
{
my($dbh, $table)  = @_;
my($MODIFY) = "UPDATE %s SET DLCount = %s WHERE UniqKey=%s";
my($sql);
my($tmp);
my($lr);

	# Return the last increment value
	my($errn, $errs, $lr) = getLastRowNumber($dbh, $table);
	return($errn, $errs) if $errn;

    $lr += 1;
    $sql = sprintf( $MODIFY, $table, $lr, 0 );

    $dbh->do($sql);
    return($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getLastRowNumber
{
my($dbh, $table)  = @_;
my($LIST) = "SELECT DLCount FROM %s WHERE UniqKey=%s";
my($sql);
my($sth);
my($tmp);

    $sql = sprintf($LIST, $table, 0);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, -1) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr, -1) if $DBI::err;

    ($Rows) = $sth->fetchrow_array; # Skip first entry

	if ($Rows eq "")
	{
		# Set initial value to 0
		$Rows = 0;
	}

    return (0, "", $Rows);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_GraffitiByUK
{
my($dbh, $table, $UK)  = @_;
my($LIST) = "SELECT * FROM %s WHERE UniqKey=%s";
my($sql);
my($sth);
my(@row);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

    $sql = sprintf($LIST, $table, $dbh->quote($UK));
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_GraffitiBySize
{
my($dbh, $table, $ImgSize, $Pending, $ord, $tim)  = @_;
my($LIST) = "SELECT * FROM %s WHERE ImgSize=%s AND Pending%s AND DateC>%d ORDER BY DateC %s";
my($p1);
my($sql);
my($sth);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

	if ($Pending eq 'N')
	{
		$p1 = "='N'";
	}
	else
	{
		$p1 = " IN ('N', 'Y')";
	}

    $sql = sprintf($LIST, $table, $dbh->quote($ImgSize), $p1, (time - $tim), $ord);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();

    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_GraffitiBySizeOrderbyTitle
{
my($dbh, $table, $ImgSize, $Pending, $ord, $tim)  = @_;
my($LIST) = "SELECT * FROM %s WHERE ImgSize=%s AND Pending%s AND DateC>%d ORDER BY Title %s";
my($p1);
my($sql);
my($sth);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

	if ($Pending eq 'N')
	{
		$p1 = "='N'";
	}
	else
	{
		$p1 = " IN ('N', 'Y')";
	}

    $sql = sprintf($LIST, $table, $dbh->quote($ImgSize), $p1, (time - $tim), $ord);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();

    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_GraffitiBySizeOrderbyRank
{
my($dbh, $table, $ImgSize, $Pending, $ord, $tim)  = @_;
my($LIST) = "SELECT * FROM %s WHERE ImgSize=%s AND Pending%s AND DateC>%d ORDER BY CurRank %s";
my($p1);
my($sql);
my($sth);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

	if ($Pending eq 'N')
	{
		$p1 = "='N'";
	}
	else
	{
		$p1 = " IN ('N', 'Y')";
	}

    $sql = sprintf($LIST, $table, $dbh->quote($ImgSize), $p1, (time - $tim), $ord);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();

    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_GraffitiByDLCountandSize
{
my($dbh, $table, $ImgSize, $Pending, $ord, $tim)  = @_;
my($LIST) = "SELECT * FROM %s WHERE ImgSize=%s AND Pending%s AND DateC>%d ORDER BY DLCount %s";
my($p1);
my($sql);
my($sth);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

	if ($Pending eq 'N')
	{
		$p1 = "='N'";
	}
	else
	{
		$p1 = " IN ('N', 'Y')";
	}

    $sql = sprintf($LIST, $table, $dbh->quote($ImgSize), $p1, (time - $tim), $ord);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();

    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_GraffitiByRankandSize
{
my($dbh, $table, $RankLow, $RankHigh, $ImgSize, $Pending, $ord, $tim)  = @_;
my($LIST) = "SELECT * FROM %s WHERE CurRank BETWEEN %f AND %f AND ImgSize=%s AND Pending%s AND DateC>%d ORDER BY CurRank %s";
my($p1);
my($sql);
my($sth);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

	if ($Pending eq 'N')
	{
		$p1 = "='N'";
	}
	else
	{
		$p1 = " IN ('N', 'Y')";
	}

    $sql = sprintf($LIST, $table, $RankLow, $RankHigh, $dbh->quote($ImgSize), $p1, (time - $tim), $ord);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();

    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_GraffitiByUserIDandSize
{
my($dbh, $table, $UserID, $ImgSize, $Pending, $ord, $tim)  = @_;
my($LIST) = "SELECT * FROM %s WHERE UserID=%s AND ImgSize=%s AND Pending%s AND DateC>%d ORDER BY DateC %s";
my($p1);
my($sql);
my($sth);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

	if ($Pending eq 'N')
	{
		$p1 = "='N'";
	}
	else
	{
		$p1 = " IN ('N', 'Y')";
	}

    $sql = sprintf($LIST, $table, $dbh->quote($UserID), $dbh->quote($ImgSize), $p1, (time - $tim), $ord);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();


    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_GraffitiSearchTitleandSize
{
my($dbh, $table, $Title, $ImgSize, $Pending, $ord, $tim)  = @_;
my($LIST) = "SELECT * FROM %s WHERE lower(Title) LIKE %s AND ImgSize=%s AND Pending%s AND DateC>%d ORDER BY Title %s";
my($p1, $searchStr);
my($sql);
my($sth);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

	if ($Pending eq 'N')
	{
		$p1 = "='N'";
	}
	else
	{
		$p1 = " IN ('N', 'Y')";
	}

	# Use wildcards for string
	$Title =~ y/A-Z/a-z/;
	$searchStr = $Title."%";

    $sql = sprintf($LIST, $table, $dbh->quote($searchStr), $dbh->quote($ImgSize), $p1, (time - $tim), $ord);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();

    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getNextRow_Graffiti
{
my($sth)  = @_;
my(@row, @rowR);
my($len, $i, $j, $jb, $k, $tmp);
my($tchr, @achr);

    (@row) = $sth->fetchrow_array;
#	if ($row[0] == 0)
#	{
#		# Throw away all reads with UniqKey of Zero.
#		(@row) = $sth->fetchrow_array;
#	}

    $len = @row;
    if( $len <= 0 )
    {
        return(@rowR);
    }
    $j = 0;
    for($i=0; $i<$len; $i++)
    {
        $rowR[$i] = $row[$i];
        $j++;
    }

    return (@rowR);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub insertRow_Graffiti
{
#                 UserID   ImgSize   Title   Descriptor   Cmt   DLCount   RankTotal   RankCnt   CurRank   Pending   AdminID   DateC   DateA   VMS
my($dbh, $table, $UserID, $ImgSize, $Title, $Descriptor, $Cmt, $DLCount, $RankTotal, $RankCnt, $CurRank, $Pending, $AdminID, $DateC, $DateA, $VMS)  = @_;
my($sql);
my($sth);
my ($errn, $errs, $UniqKey);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

	# Generate a unique value
	($errn, $errs, $UniqKey) = getLastRowNumber($dbh, $table);
	return($errn, $errs) if $errn;

    $sth = $dbh->prepare("INSERT INTO $table ( UniqKey, UserID, ImgSize, Title, Descriptor, Cmt, DLCount, RankTotal, RankCnt, CurRank, Pending, AdminID, DateC, DateA, VMS )  VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )");

    $sth->bind_param( 1, $UniqKey);
    $sth->bind_param( 2, $UserID);
    $sth->bind_param( 3, $ImgSize);
    $sth->bind_param( 4, $Title);
    $sth->bind_param( 5, $Descriptor);
    $sth->bind_param( 6, $Cmt);
    $sth->bind_param( 7, $DLCount);
    $sth->bind_param( 8, $RankTotal);
	$sth->bind_param( 9, $RankCnt);
	$sth->bind_param(10, $CurRank);
	$sth->bind_param(11, $Pending);
    $sth->bind_param(12, $AdminID);
    $sth->bind_param(13, $DateC);
    $sth->bind_param(14, $DateA);

    $attrib{'ora_type'} = 24; # -- 24 is LONG RAW type code
    $sth->bind_param(15, $VMS, \%attrib); # -- must pass reference to attrib

    $sth->execute(); # -- no parameters to execute
    return($DBI::err, $DBI::errstr) if $DBI::err;

#	$dbh->commit();			# Not required.  Auto Commit enabled
#	return($DBI::err, $DBI::errstr) if $DBI::err;

	# Increment the Unique Key counter
	($errn, $errs, $UniqKey) = incrementLastRowNumber($dbh, $table);
	return($errn, $errs) if $errn;

    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub modifyRow_GraffitiByUK
{
#                 UniqKey   UserID   ImgSize   Title   Descriptor   Cmt   DLCount   RankTotal   RankCnt   CurRank   Pending   AdminID   DateA   VMS
my($dbh, $table, $UniqKey, $UserID, $ImgSize, $Title, $Descriptor, $Cmt, $DLCount, $RankTotal, $RankCnt, $CurRank, $Pending, $AdminID, $DateA, $VMS)  = @_;
my($sql);
my($sth);
my($tmp);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

	$sth = $dbh->prepare("UPDATE $table SET UserID=?, ImgSize=?, Title=?, Descriptor=?, Cmt=?, DLCount=?, RankTotal=?, RankCnt=?, CurRank=?, Pending=?, AdminID=?, DateA=?, VMS=? WHERE UniqKey=?");

	$sth->bind_param(1, $UserID);
	$sth->bind_param(2, $ImgSize);
	$sth->bind_param(3, $Title);
	$sth->bind_param(4, $Descriptor);
	$sth->bind_param(5, $Cmt);
	$sth->bind_param(6, $DLCount);
	$sth->bind_param(7, $RankTotal);
	$sth->bind_param(8, $RankCnt);
	$sth->bind_param(9, $CurRank);
	$sth->bind_param(10, $Pending);
	$sth->bind_param(11, $AdminID);
	$sth->bind_param(12, $DateA);

	$attrib{'ora_type'} = 24; # -- 24 is LONG RAW type code
	$sth->bind_param(13, $VMS, \%attrib); # -- must pass reference to attrib
#	$sth->bind_param(13, $VMS, { ora_type => 24 });
	$sth->bind_param(14, $UniqKey);

	$sth->execute(); # -- no parameters to execute

    return($DBI::err, $DBI::errstr) if $DBI::err;

#	$dbh->commit;			# Not required.  Auto Commit enabled
#	$sth->finish();
    return($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub modifyCountRow_GraffitiByUK
{
#                 UniqKey   DLCount   RankTotal   RankCnt   CurRank
my($dbh, $table, $UniqKey, $DLCount, $RankTotal, $RankCnt, $CurRank) = @_;
my($sql);
my($p1, $p2, $p3, $p4, $p5);
my($sth);
my($tmp);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

    $p1  = $dbh->quote($UniqKey);
    $p2  = $dbh->quote($DLCount);
    $p3  = $RankTotal;
    $p4  = $RankCnt;
    $p5  = $CurRank;

    $sql = qq~
UPDATE $table SET DLCount=$p2, RankTotal=$p3, RankCnt=$p4, CurRank=$p5
  WHERE UniqKey=$p1
~;
#    $sql = "UPDATE $table SET DLCount=$p2, RankTotal=$p3, RankCnt=$p4, CurRank=$p5 WHERE UniqKey=$p1 \;";
    $dbh->do($sql);

    return($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub deleteRow_GraffitiByUK
{
my($dbh, $table, $UK)  = @_;
my($DELETE) = "DELETE FROM %s WHERE UniqKey = %s";
my($sql);
my($sth);

	# Set up Long Information
	$dbh->{LongReadLen} = $RawSize;
	$dbh->{LongTruncOk} = 1;

    $sql = sprintf( $DELETE, $table, $dbh->quote($UK) );

    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr) if $DBI::err;

    $sth->execute();
#	$dbh->commit();			# Not required.  Auto Commit enabled
    return ($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");

}

1; #return true 

