use strict;



#+-----------------------------------------------------+

#|                                                     |

#+-----------------------------------------------------+

sub create_User

{

my($dbh, $table)  = @_;

my($CREATE) = "CREATE TABLE %s ( UniqKey CHAR(22), Email VARCHAR2(100), Name VARCHAR2(50), City VARCHAR2(50), State CHAR(2), Country CHAR(2), SE CHAR(1), Admin CHAR(1), GM NUMBER, SM NUMBER, BM NUMBER, BR NUMBER, DateC INT, DateM INT )";

my($sql);



    $sql = sprintf($CREATE, $table);



    $dbh->do($sql);

    return($DBI::err, $DBI::errstr) if $DBI::err;



    return(0, "");

}



#+-----------------------------------------------------+

#|                                                     |

#+-----------------------------------------------------+

sub delete_User

{

my($dbh, $table)  = @_;

my($DROP) = "DROP TABLE %s";

my($sql);



    $sql = sprintf($DROP, $table);



    $dbh->do($sql);

    return($DBI::err, $DBI::errstr) if $DBI::err;

    return(0, "");

}



#+-----------------------------------------------------+

#|                                                     |

#+-----------------------------------------------------+

sub selectAllRows_User

{

my($dbh, $table)  = @_;

my($LIST) = "SELECT * FROM %s WHERE DateC > 0 ORDER BY DateM";

my($sql);

my($sth);



    $sql = sprintf($LIST, $table);

    $sth = $dbh->prepare($sql);

    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;



    $sth->execute();

    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;



    return (0, "", $sth);

}



#+-----------------------------------------------------+

#|                                                     |

#+-----------------------------------------------------+

sub getUK_UserByEmail

{

my($dbh, $table, $Email)  = @_;

my($LIST) = "SELECT * FROM %s WHERE Email like %s";

my($sql);

my($sth);

my($row);



	# Use wildcards for string

	my $searchStr = "%".$Email."%";



    $sql = sprintf($LIST, $table, $dbh->quote($searchStr));

    $sth = $dbh->prepare($sql);

    return ($DBI::err, $DBI::errstr, $row) if $DBI::err;

	

    $sth->execute();

    return ($DBI::err, $DBI::errstr, $row) if $DBI::err;



   ($row) = getNextRow_User($sth);



    return (0, "", $row);

}



#+--------------------------------------------------------+

#| Get User Key by User Name                              |

#| Make an exact search by name since each name is unique |

#+--------------------------------------------------------+

sub getUK_UserByName

{

my($dbh, $table, $Name)  = @_;

my($LIST) = "SELECT * FROM %s WHERE Name=%s";

my($sql);

my($sth);

my($row);



    $sql = sprintf($LIST, $table, $dbh->quote($Name));

    $sth = $dbh->prepare($sql);

    return ($DBI::err, $DBI::errstr, $row) if $DBI::err;

	

    $sth->execute();

    return ($DBI::err, $DBI::errstr, $row) if $DBI::err;



    ($row) = getNextRow_User($sth);



    return (0, "", $row);

}



#+-----------------------------------------------------+

#|                                                     |

#+-----------------------------------------------------+

sub getRow_UserByUK

{

my($dbh, $table, $UniqKey)  = @_;

my($LIST) = "SELECT * FROM %s WHERE UniqKey='%s'";

my($sql);

my($sth);

my(@row);



	# Ensure number is padded with leading zeros

	my $id = substr("0000000000000000000000".$UniqKey, length($UniqKey), 22 );



    $sql = sprintf($LIST, $table, $id);

    $sth = $dbh->prepare($sql);

    return ($DBI::err, $DBI::errstr, @row) if $DBI::err;



    $sth->execute();

    return ($DBI::err, $DBI::errstr, @row) if $DBI::err;



    (@row) = getNextRow_User($sth);



    return (0, "", @row);

}



#+-----------------------------------------------------+

#|                                                     |

#+-----------------------------------------------------+

sub getNextRow_User

{

my($sth)  = @_;

my(@row, @rowR);

my($len, $i, $j, $jb, $k, $tmp);

my($tchr, @achr);



    (@row) = $sth->fetchrow_array;

    $len = @row;

    if( $len <= 0 )

    {

        return(@rowR);

    }

    $j = 0;

    for($i=0; $i<$len; $i++)

    {

		$rowR[$j] = $row[$i];

		$j++;

    }



    return (@rowR);



}



#+-----------------------------------------------------+

#|                                                     |

#+-----------------------------------------------------+

sub insertRow_User

{

#                 UniqKey   Email   Name   City   State   Country   SE   Admin   GM   SM   BM   BR   DateC   DateM   

my($dbh, $table, $UniqKey, $Email, $Name, $City, $State, $Country, $SE, $Admin, $GM, $SM, $BM, $BR, $DateC, $DateM)  = @_;

my($sql);

my($p1, $p2, $p3, $p4, $p5, $p6, $p7, $p8, $p9, $p10, $p11, $p12, $p13, $p14);

my($sth);



	# Ensure number is padded with leading zeros

	my $id = substr("0000000000000000000000".$UniqKey, length($UniqKey), 22 );



    $p1  = $dbh->quote($id);

    $p2  = $dbh->quote($Email);

    $p3  = $dbh->quote($Name);

    $p4  = $dbh->quote($City);

    $p5  = $dbh->quote($State);

    $p6  = $dbh->quote($Country);

    $p7  = $dbh->quote($SE);

	$p8  = $dbh->quote($Admin);

    $p9  = $dbh->quote($GM);

    $p10 = $dbh->quote($SM);

    $p11 = $dbh->quote($BM);

    $p12 = $dbh->quote($BR);

    $p13 = $DateC;

    $p14 = $DateM;



    $sql = qq~

INSERT INTO $table ( UniqKey, Email, Name, City, State, Country, SE, Admin, GM, SM, BM, BR, DateC, DateM ) 

  VALUES ( $p1, $p2, $p3, $p4, $p5, $p6, $p7, $p8, $p9, $p10, $p11, $p12, $p13, $p14 )

~;

#print "-- $sql --<br>";

    $dbh->do($sql);



    return($DBI::err, $DBI::errstr . $sql, "") if $DBI::err;

    return(0, "", $id);

}



#+-----------------------------------------------------+

#|                                                     |

#+-----------------------------------------------------+

sub deleteRow_UserByUK

{

my($dbh, $table, $UniqKey)  = @_;

my($DELETE) = "DELETE FROM %s WHERE UniqKey = %s";

my($sql);

my($sth);



	# Ensure number is padded with leading zeros

	my $id = substr("0000000000000000000000".$UniqKey, length($UniqKey), 22 );



    $sql = sprintf( $DELETE, $table, $id );



    $sth = $dbh->prepare($sql);

    return ($DBI::err, $DBI::errstr) if $DBI::err;



    $sth->execute();

    return ($DBI::err, $DBI::errstr) if $DBI::err;

    return(0, "");



}



#+-----------------------------------------------------+

#|                                                     |

#+-----------------------------------------------------+

sub clearRow_User

{

my($dbh, $table, $UniqKey)  = @_;

#											  UniqKey  Email  Name City State Country SE  Admin  GM SM BM BR DateM

	return( modifyRow_UserByUK($dbh, $table, $UniqKey, '',    '',  '',  '',   '',     '', '',     0, 0, 0, 0, time ) );

}



#+-----------------------------------------------------+

#|                                                     |

#+-----------------------------------------------------+

sub modifyRow_UserByUK

{

my($dbh, $table, $UniqKey, $Email, $Name, $City, $State, $Country, $SE, $Admin, $GM, $SM, $BM, $BR, $DateM)  = @_;

my($p1, $p2, $p3, $p4, $p5, $p6, $p7, $p8, $p9, $p10, $p11, $p12, $p13);

my($sql);



	# Ensure number is padded with leading zeros

	my $id = substr("0000000000000000000000".$UniqKey, length($UniqKey), 22 );



    $p1  = $dbh->quote($id);

    $p2  = $dbh->quote($Email);

    $p3  = $dbh->quote($Name);

    $p4  = $dbh->quote($City);

    $p5  = $dbh->quote($State);

    $p6  = $dbh->quote($Country);

    $p7  = $dbh->quote($SE);

	$p8  = $dbh->quote($Admin);

    $p9  = $dbh->quote($GM);

    $p10 = $dbh->quote($SM);

    $p11 = $dbh->quote($BM);

    $p12 = $dbh->quote($BR);

    $p13 = $DateM;



    $sql = qq~

UPDATE $table SET Email=$p2, Name=$p3, City=$p4, State=$p5, Country=$p6, SE=$p7, Admin=$p8, GM=$p9, SM=$p10, BM=$p11, BR=$p12, DateM=$p13

  WHERE UniqKey=$p1

~;



#print "-- $sql --\n";



    $dbh->do($sql);

    return($DBI::err, $DBI::errstr) if $DBI::err;

    return(0, "");



}



1; #return true 



