
$Rows  = 0;

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub create_WRank
{
my($dbh, $table)  = @_;
my($CREATE) = "CREATE TABLE %s ( UniqKey CHAR(22), EventID CHAR(4), GameMode CHAR(1), Stage CHAR(1), Chr CHAR(1), Rank CHAR(1), Score NUMBER, Cmt VARCHAR2(128), DateM INT  )";
my($sql);

    $sql = sprintf($CREATE, $table);

    $dbh->do($sql);
    return($DBI::err, $DBI::errstr) if $DBI::err;

    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub delete_WRank
{
my($dbh, $table)  = @_;
my($DROP) = "DROP TABLE %s";
my($sql);

    $sql = sprintf($DROP, $table);

    $dbh->do($sql);
    return($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub selectAllRows_WRank
{
my($dbh, $table)  = @_;
my($LIST) = "SELECT * FROM %s ORDER BY Score";
my($sql);
my($sth);

    $sql = sprintf($LIST, $table);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

#    $sth->fetchrow_array; # Skip first entry

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_WRankByUK
{
my($dbh, $table, $UK)  = @_;
my($LIST) = "SELECT * FROM %s WHERE UniqKey=%s ORDER BY Score";
#my($LIST) = "SELECT * FROM %s WHERE UniqKey=%s";
my($sql);
my($sth);
my(@row);

    $sql = sprintf($LIST, $table, $dbh->quote($UK));
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_WRankByEvent
{
my($dbh, $table, $Event, $ord, $tim)  = @_;
my($LIST) = "SELECT * FROM %s WHERE EventID=%s AND DateM>%d ORDER BY Score %s";
my($sql);
my($sth);
my(@row);

    $sql = sprintf($LIST, $table, $dbh->quote($Event), (time - $tim), $ord);
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr, $sth) if $DBI::err;

    return (0, "", $sth);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getRow_WRankByUKandEVENT
{
my($dbh, $table, $UK, $EventID)  = @_;
my($LIST) = "SELECT * FROM %s WHERE UniqKey=%s AND EventID=%s ORDER BY Score";
my($sql);
my($sth);
my(@row);

    $sql = sprintf($LIST, $table, $dbh->quote($UK), $dbh->quote($EventID));
    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr, @row) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr, @row) if $DBI::err;

    (@row) = getNextRow_WRank($sth);

    return (0, "", @row);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub getNextRow_WRank
{
my($sth)  = @_;
my(@row, @rowR);
my($len, $i, $j, $jb, $k, $tmp);
my($tchr, @achr);

    (@row) = $sth->fetchrow_array;
#print "|||| $row[0] ------<br>";
    $len = @row;
    if( $len <= 0 )
    {
        return(@rowR);
    }
    $j = 0;
    for($i=0; $i<$len; $i++)
    {
        $rowR[$i] = $row[$i];
        $j++;
    }

    return (@rowR);

}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub insertRow_WRank
{
#                 UniqKey   EventID   GameMode   Stage   Chr   Rank   Score   Cmt   DateM
my($dbh, $table, $UniqKey, $EventID, $GameMode, $Stage, $Chr, $Rank, $Score, $Cmt, $DateM)  = @_;
my($sql);
my($p1, $p2, $p3, $p4, $p5, $p6, $p7, $p8, $p9);
my($sth);
my($tmp);

    $p1  = $dbh->quote($UniqKey);
    $p2  = $dbh->quote($EventID);
    $p3  = $dbh->quote($GameMode);
    $p4  = $dbh->quote($Stage);
    $p5  = $dbh->quote($Chr);
    $p6  = $dbh->quote($Rank);
    $p7  = $Score;
    $p8  = $dbh->quote($Cmt);
    $p9  = $DateM;

    $sql = qq~
INSERT INTO $table ( UniqKey, EventID, GameMode, Stage, Chr, Rank, Score, Cmt, DateM ) 
  VALUES ( $p1, $p2, $p3, $p4, $p5, $p6, $p7, $p8, $p9  )
~;
#print "-- $sql --<br>";
    $dbh->do($sql);


    return($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub modifyRow_WRankByUKandEVENT
{
#                 UniqKey   EventID   GameMode   Stage   Chr   Rank   Score   Cmt   DateM
my($dbh, $table, $UniqKey, $EventID, $GameMode, $Stage, $Chr, $Rank, $Score, $Cmt, $DateM)  = @_;
my($sql);
my($p1, $p2, $p3, $p4, $p5, $p6, $p7, $p8, $p9);
my($sth);
my($tmp);

    $p1  = $dbh->quote($UniqKey);
    $p2  = $dbh->quote($EventID);
    $p3  = $dbh->quote($GameMode);
    $p4  = $dbh->quote($Stage);
    $p5  = $dbh->quote($Chr);
    $p6  = $dbh->quote($Rank);
    $p7  = $Score;
    $p8  = $dbh->quote($Cmt);
    $p9  = $DateM;

    $sql = qq~
UPDATE $table SET GameMode=$p3, Stage=$p4, Chr=$p5, Rank=$p6, Score=$p7, Cmt=$p8, DateM=$p9
  WHERE UniqKey=$p1 AND EventID=$p2
~;
    $dbh->do($sql);


    return($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub deleteRow_WRankByUK
{
my($dbh, $table, $UK)  = @_;
my($DELETE) = "DELETE FROM %s WHERE UniqKey = %s";
my($sql);
my($sth);

    $sql = sprintf( $DELETE, $table, $dbh->quote($UK) );

    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");

}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub deleteRow_WRankByUKandEVENT
{
my($dbh, $table, $UK, $EventID)  = @_;
my($DELETE) = "DELETE FROM %s WHERE UniqKey = %s AND EventID=%s";
my($sql);
my($sth);

    $sql = sprintf( $DELETE, $table, $dbh->quote($UK), $dbh->quote($EventID) );

    $sth = $dbh->prepare($sql);
    return ($DBI::err, $DBI::errstr) if $DBI::err;

    $sth->execute();
    return ($DBI::err, $DBI::errstr) if $DBI::err;
    return(0, "");

}

1; #return true 

