#!/usr/bin/perl -I..
# Dreamcast Version
# Jet Grind Radio
# User Administration Displayer
# 


use strict;

use CGI;
use	DC;
use POSIX	'strftime';
use DB;


## Set up variables
use vars	(	'$dc',	# DC object
				'@IN',
				'$errorURL', '$cgiPath', '$date', '$mailprog', '$adminkey',
				'$Type', '$mode', '$EventID', '$Track', '$ftype', '$Mode', '$Stage', '$Chara',
				'@GameType', '@TrackName', '@TimeTbl',
			);

#...............................................
# Handling time
	$date = strftime("CREATED ON %m/%d/%Y, %I:%M %p (%Z)", localtime);

	my $q = new CGI;
	$dc = new DC($q);
	$dc->q->import_names('IN');

	$errorURL = "cgi-bin/jetgrindradio/admin/showhtml.cgi?page=admin_user.html";
	$cgiPath = "/cgi-bin/jetgrindradio/admin/user.cgi";
	$mailprog = '/usr/lib/sendmail';

	if ($dc->q->param('command') eq 'update') {
		# Record data into Database
		my ($dbh, $errN, $errstr, @row, $key, $adminflag);
					
		# Read user information from the table
		if($IN::mailid ne "") {
			$key = $dc->get_key($IN::mailid);
			if ($key eq "")
			{
				$dc->error("[admin_user] Sorry, no matches were found containing <b>$key</b>.<p>Please try again. ", $errorURL);
			}
			else
			{
				($dbh, $errstr) = DB::openOracleConnection();
				if( !$dbh )
				{
					$dc->error("[admin_user] Error connecting to database: $errstr");
				}

				($errN, $errstr, @row) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $key );
				if ($errN)
				{
					$dc->error("[admin_user] Fetching user key: $errN .... $errstr", $errorURL);
				}
				
				$adminflag = $row[$dc->UserOff('ADMIN')];
				
				if ($IN::access == 0)
				{
					#Increase Gold
					$adminflag = 'Y';
				}
				elsif ($IN::access == 1)
				{
					#Increase Silver
					$adminflag = 'N';
				}
	
				if ($IN::access >= 0)
				{
					# Update user table information
					($errN, $errstr)       = DB::modifyRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $row[$dc->UserOff('USERID')], $row[$dc->UserOff('EMAIL')], $row[$dc->UserOff('NAME')], $row[$dc->UserOff('CITY')], $row[$dc->UserOff('STATE')], $row[$dc->UserOff('COUNTRY')], $row[$dc->UserOff('MFLAG')], $adminflag, $row[$dc->UserOff('GOLD')], $row[$dc->UserOff('SILVER')], $row[$dc->UserOff('BRONZE')], $row[$dc->UserOff('BLUERIB')], time );
					if ($errN)
					{
						$dc->error("[admin_user] Unable to update user info: $errN .... $errstr", $errorURL);
					}
				}

				DB::closeOracleConnection( $dbh );
				
				# Display Record
				&output_verify($key);
			}
		}
	}

exit(0);

#--------------------------------------------------------
# Result Output
#--------------------------------------------------------
sub output_verify {
	my $UserKey = shift;

	my ($dbh, $errN, $errstr, @row, $loop);

	($dbh, $errstr) = DB::openOracleConnection();
	if( !$dbh )
	{
		$dc->error("[admin_user] Error connecting to database: $errstr");
	}

	($errN, $errstr, @row) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $UserKey );
	if ($errN)
	{
		$dc->error("[admin_user] Fetching user key: $errN .... $errstr", $errorURL);
	}
				
	DB::closeOracleConnection( $dbh );
	
	if ($UserKey eq $row[$dc->UserOff('KEY')])
	{
		#User is defined in database
		print "Content-type: text/html\n\n";
		print <<EOF;

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title>Jet Grind Radio - Admin Validation</title>
<meta name=x-uirequest content=nohscroll>
</head>

<body bgcolor=#E6CE00 x-marginleft=0 TEXT="#660000" LINK="#B96800" VLINK="#B96800" ALINK="#B96800" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0>


<center>

<TABLE WIDTH="550" BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<tr>
		<TD valign=top width=550><img src="/images/title_graffiti.gif" width=550 height=46 border=0 alt=""></td>
	</tr>
</table>
<TABLE WIDTH="550" BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<tr>
		<TD width=7 valign=top><img src="/images/clear.gif" width=7 height=1 border=0 alt=""></td>
		<TD width=368 valign=top>
<!-- insert content here -->

<TABLE border=1 cellpadding=5 cellspacing=0 BGCOLOR="#CCCCCC">
<TR>
<TD height="60" align="left" colspan=2 BGCOLOR="#666666">
<FONT COLOR="white">DISPLAY USER INFORMATION</FONT>
</TD>
</TR>
<TR>
<TD WIDTH="140">Name:</TD>
<TD>$row[$dc->UserOff('NAME')]</TD>
</TR>

<TR>
<TD>E-Mail:</TD>
<TD>$row[$dc->UserOff('EMAIL')]</TD>
</TR>

<TR>
<TD>
EOF
		if ($dc->Flags($row[$dc->UserOff('COUNTRY')]) ne "")
		{
			print "<img src=\"/images/flags/".$dc->Flags($row[$dc->UserOff('COUNTRY')])."\" width=40 height=20 border=0 align=\"right\">";	
		} else {
			# Draw the generic flag
			print "<img src=\"/images/flags/flag_other.gif\" width=40 height=20 border=0 align=\"right\">";
		}
		print "Location:</TD><TD>\n";

        print "$row[$dc->UserOff('CITY')], ";
		if ($row[$dc->UserOff('STATE')] ne "") {
			printf "%s, ", $dc->state_name($row[$dc->UserOff('STATE')]);
		}
		printf "%s\n", $dc->country_name($row[$dc->UserOff('COUNTRY')]);

    print <<EOF;
	</TD></TR>

<TR>
<TD>Admin Rights:</TD>
<TD>
EOF

	if ($row[$dc->UserOff('ADMIN')] eq 'Y')
	{
		print "Administrator Privileges\n";
	}
	else
	{
		print "No administrator rights\n";
	}

	print <<EOF;
</TD></TR>

<TR>
<TD VALIGN="TOP" COLSPAN="2">Awards:<BR>
EOF
		my $count = 0;
		for ($loop = 0; $loop < $row[$dc->UserOff('GOLD')]; ++$loop)
		{
			print "<img src=\"/images/wrank/can_gold.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
			++$count;
			if ($count >= 8)
			{
				print "<BR>\n";
				$count = 0;
			}
		}

		for ($loop = 0; $loop < $row[$dc->UserOff('SILVER')]; ++$loop)
		{
			print "<img src=\"/images/wrank/can_silver.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
			++$count;
			if ($count >= 8)
			{
				print "<BR>\n";
				$count = 0;
			}
		}

		for ($loop = 0; $loop < $row[$dc->UserOff('BRONZE')]; ++$loop)
		{
			print "<img src=\"/images/wrank/can_bronze.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
			++$count;
			if ($count >= 8)
			{
				print "<BR>\n";
				$count = 0;
			}
		}

		for ($loop = 0; $loop < $row[$dc->UserOff('BLUERIB')]; ++$loop)
		{
			print "<img src=\"/images/wrank/ribbon_big.gif\" width=50 height=50 border=0 hspace=5 align=\"top\">";
			++$count;
			if ($count >= 8)
			{
				print "<BR>\n";
				$count = 0;
			}
		}

	print <<EOF;
</TD>
</TR>

</TABLE>
<BR>

<!-- end of content -->
		<a href="/cgi-bin/jetgrindradio/admin/showhtml.cgi?page=admin_user.html"><img src="/images/button_back.gif" width=200 height=30 border=1 alt="" align=right></a></td>
		<TD width=175 valign=top><img src="/images/graphic_graffiti.gif" width=175 height=400 border=0 alt=""></td>
	</tr>
</table>

</center>
</body>

</html>
EOF
	}
	else
	{
		$dc->error("[admin_user] User not found in database.\n", $errorURL);
	}
}

#------------------------ EOF --------------------------
