#!/usr/bin/perl -I..
# Dreamcast Version
# Jet Grind Radio
# World Rankings Displayer
# 


use strict;

use CGI;
use	DC;
use POSIX	'strftime';
use DB;


## Set up variables
use vars	(	'$dc',	# DC object
				'@IN',
				'$errorURL', '$cgiPath', '$date', '$mailprog', '$adminkey',
				'$Type', '$mode', '$EventID', '$Track', '$ftype', '$Mode', '$Stage', '$Chara',
				'@GameType', '@TrackName', '@TimeTbl', '@StageName','@LevelName','@StageTbl'
			);

@StageName = ( 'Shibuya-Cho',
               'Kogane-Cho',
               'Benten-Cho',
               'Bantam Street',
               'Grind Square',
             );

@GameType = (  'Story',
			   'Jet Crush',
               'Jet Technique',
               'Jet Graffiti',
             );

@LevelName = ('Shibuya GG','Love Trap','Love Attack','Explosion','',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'The Monster of Kogane','No. 540','Kogane Circus','Fight or Flight','',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'Benten Boogie','Graffiti High','Noise Reduction','Benten Burning','Behind the Mask',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'Tag or Die','','','','',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'Rock\' N Roll Grind','','','','',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			 );

# Stage Related Data
@StageTbl = (
		# key => [ Stage Name, Stage Graphic, VMU File ]
		[ "/images/maptext_shibuya.gif", "/images/maps_shibuya.gif", "JETGRIND_SYS"],
		[ "/images/maptext_kogane.gif", "/images/maps_kogane.gif", "JETGRIND_SYS"],
		[ "/images/maptext_benten.gif", "/images/maps_benten.gif", "JETGRIND_SYS"],
		[ "/images/maptext_bantam.gif", "/images/maps_bantam.gif", "JETGRIND_SYS"],
		[ "/images/maptext_grindsq.gif", "/images/maps_grindsq.gif", "JETGRIND_SYS"],
        );

#...............................................
# Handling time
	$date = strftime("CREATED ON %m/%d/%Y, %I:%M %p (%Z)", localtime);

	my $q = new CGI;
	$dc = new DC($q);
	$dc->q->import_names('IN');

	$errorURL = "cgi-bin/jetgrindradio/showhtml.cgi?page=admin.html";
	$cgiPath = "/cgi-bin/jetgrindradio/admin/wrank.cgi";
	$mailprog = '/usr/lib/sendmail';
	$adminkey = $dc->DBaseTable('ADMIN');

	if ($dc->q->param('command') eq 'contest')
	{
		$Type = 0;
		&check_data;

		# Record data into Database
		my ($dbh, $sth, $errN, $errstr, @row, $key);
					
		# Read user information from the table
		# Administration name uses completely unique and illegal characters so it can't be duplicated
		$key = $dc->make_key($adminkey);
		
		($dbh, $errstr) = DB::openOracleConnection();
		if( !$dbh )
		{
			$dc->error("[admin_wrank] Error connecting to database: $errstr");
		}

		if ($IN::type == 3)
		{
			$dc->q->param('Message', "World Ranking Contest has been deleted.");

			# Delete the contest
		    ($errN, $errstr)       = DB::deleteRow_WRankByUKandEVENT( $dbh, $dc->DBaseTable('WRANK'), $key, $EventID );
			if ($errN)
			{
				$dc->error("[admin_wrank] Unable to delete WRank entry: $errN .... $errstr", $errorURL);
			}
		}
		else
		{
			if ($IN::type == 0)
			{
				$dc->q->param('Message', "World Ranking Contest has been started.");
			}
			elsif ($IN::type == 1)
			{
				$dc->q->param('Message', "World Ranking Contest has been stopped and top 50 winners have been e-mailed to $IN::mailid.");

				my $adminkey = $dc->get_key($dc->DBaseTable('ADMIN'));

				# Send mail
				if(open(MAIL, "|$mailprog $IN::mailid")) {
					# Header output
					print MAIL "From: support\@dreamcast.com\n";
					print MAIL "Reply-to: support\@dreamcast.com\n";
					print MAIL "Subject: Winners of $StageName[$Track] - $GameType[$Mode] Attack\n\n";

					if ($Mode == 4)
					{
						($errN, $errstr, $sth) = DB::getRow_WRankByEVENTandSCORE( $dbh, $dc->DBaseTable('WRANK'), $EventID, (5*365*24*60*60) );
						if ($errN)
						{
							$dc->error("[admin_wrank] Unable to get Tournament Events: $errN .... $errstr", $errorURL);
						}
					}
					else
					{
						($errN, $errstr, $sth) = DB::getRow_WRankByEvent( $dbh, $dc->DBaseTable('WRANK'), $EventID, "ASC", (5*365*24*60*60) );
						if ($errN)
						{
							$dc->error("[admin_wrank] Unable to get Ascending Events: $errN .... $errstr", $errorURL);
						}
					}

					# Body output
					print MAIL "$date\n";
					print MAIL "Top 50 entries of $StageName[$Track] - $GameType[$Mode] Attack\n";
					my $loop = 0;
					my (@user, $userkey, $score);
					
					for ($loop = 1; $loop <= 50; ++$loop)
					{
						# print out a list of the top 50 winners
						print MAIL "\nWinner #$loop:\n";
					    (@row) = DB::getNextRow_WRank($sth);
						if ($row[$dc->WRankOff('KEY')] eq $adminkey)
						{
							#Skip that record since it is the Admin record
							(@row) = DB::getNextRow_WRank($sth);
						}

						$userkey = $row[$dc->WRankOff('KEY')];
						if ($userkey ne "")
						{
							($errN, $errstr, @user) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $userkey );
							if ($errN)
							{
								$dc->error("[admin_wrank] Fetching user info: $errN .... $errstr", $errorURL);
							}

							if ($row[$dc->WRankOff('MODE')] == 1)
							{							
								my $value = int($row[$dc->WRankOff('SCORE')]/60);							
								$score = sprintf "\tTime:     %d:%02.3f\n",
								$value,
								$row[$dc->WRankOff('SCORE')] - ($value * 60);
							}
							else
							{
								my $value = int($row[$dc->WRankOff('SCORE')]);							
								$score = sprintf "\tScore:     %d\n",$value;
								
							}

							print MAIL $score;
							print MAIL "\tName:     ".$user[$dc->UserOff('NAME')]."\n";
							print MAIL "\tLocation: ".$user[$dc->UserOff('CITY')].", ";
							if ($user[$dc->UserOff('STATE')] ne "") {
								print MAIL $dc->state_name($user[$dc->UserOff('STATE')]).", ";
							}
							print MAIL $dc->country_name($user[$dc->UserOff('COUNTRY')])."\n";

							print MAIL "\tE-mail:   ".$user[$dc->UserOff('EMAIL')]."\n";
						}
					}

					close(MAIL);
				} else {
					$dc->error("Unable to send e-mail to $dc->q->param('mailid').", $errorURL);
				}
			}
			elsif ($IN::type == 2)
			{
				$dc->q->param('Message', "World Ranking Contest has been completed.<BR>Winner list link has now been enabled.<BR>People can still rank, but they are not part of the contest.");
			}

			# Read the current contest controlling entry in the database
			($errN, $errstr, @row) = DB::getRow_WRankByUKandEVENT( $dbh, $dc->DBaseTable('WRANK'), $key, $EventID );
			if ($errN)
			{
				$dc->error("[admin_wrank] Fetching WRank info: $errN .... $errstr", $errorURL);
			}

			if ($row[$dc->WRankOff('KEY')] ne $key)
			{
				# New Record
				($errN, $errstr)       = DB::insertRow_WRank( $dbh, $dc->DBaseTable('WRANK'), $key, $EventID, $Track, $Mode, $IN::type, 0.0, 0, 0, 0, time, "" );
				if ($errN)
				{
					$dc->error("[admin_wrank] Unable to create WRank info: $errN .... $errstr", $errorURL);
				}
			}
			else
			{
				# Modify existing record
				($errN, $errstr)       = DB::modifyRow_WRankByUKandEVENT( $dbh, $dc->DBaseTable('WRANK'), $key, $EventID, $Mode, $Track, 0, $IN::type, 0.0, "", time );
				if ($errN)
				{
					$dc->error("[admin_wrank] Unable to modify WRank info: $errN .... $errstr", $errorURL);
				}
			}
		}

		DB::closeOracleConnection( $dbh );
		
		# Display Record
		$dc->output_form("wrank_contest.html");
	} elsif ($dc->q->param('command') eq 'update') {
		# Record data into Database
		my ($dbh, $errN, $errstr, @row, $key, $gold, $silver, $bronze, $ribbon);
					
		# Read user information from the table
		if($IN::mailid ne "") {
			$key = $dc->get_key($IN::mailid);
			if ($key eq "")
			{
				$dc->error("Sorry, no matches were found containing <b>$key</b>.<p>Please try again. ", $errorURL);
			}
			else
			{
				($dbh, $errstr) = DB::openOracleConnection();
				if( !$dbh )
				{
					$dc->error("[admin_wrank] Error connecting to database: $errstr");
				}

				($errN, $errstr, @row) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $key );
				if ($errN)
				{
					$dc->error("[admin_wrank] Fetching user key: $errN .... $errstr", $errorURL);
				}
				
				$gold = $row[$dc->UserOff('GOLD')];
				$silver = $row[$dc->UserOff('SILVER')];
				$bronze = $row[$dc->UserOff('BRONZE')];
				$ribbon = $row[$dc->UserOff('BLUERIB')];
				$IN::mailid = $row[$dc->UserOff('EMAIL')];
				
				if ($IN::medal == 0)
				{
					#Increase Gold
					++$gold;
				}
				elsif ($IN::medal == 1)
				{
					#Increase Silver
					++$silver;
				}
				elsif ($IN::medal == 2)
				{
					#Increase Bronze
					++$bronze;
				}
				elsif ($IN::medal == 3)
				{
					#Increase Ribbon
					++$ribbon;
				}
				elsif ($IN::medal == 4)
				{
					$gold = 0;
					$silver = 0;
					$bronze = 0;
					$ribbon = 0;
				}
	
				# Send mail to user
				if (($IN::medal >= 0) && ($IN::medal < 4))
				{
					
					if(open(MAIL, "|$mailprog $IN::mailid")) {
						# Header output
						print MAIL "From: sonicteam\@sonic-adventure.com\n";
						print MAIL "Reply-to: sonicteam\@sonic-adventure.com\n";
						print MAIL "Subject: Congratulations\n\n";

						print MAIL "Dear ".$row[$dc->UserOff('NAME')].",\n\n";

						print MAIL "The Sonic Team would like to congratulate you on your excellent\n";
						print MAIL "performance in World Rankings.  We are quite impressed!\n\n";

						if ($IN::medal == 0)
						{
							print MAIL "For showing total dominance in a World Ranking contest, we are awarding\n";
							print MAIL "you a Gold Cup, our highest honor.\n\n";
						}
						elsif ($IN::medal == 1)
						{
							print MAIL "For placing 2nd place in a World Ranking contest, we are awarding you a\n";
							print MAIL "Silver Cup.\n\n";
						}
						elsif ($IN::medal == 2)
						{
							print MAIL "For placing 3rd in a World Ranking contest, we are awarding you a Bronze\n";
							print MAIL "Cup.\n\n";
						}
						elsif ($IN::medal == 3)
						{
							print MAIL "For showing great skill in a World Ranking contest, we are awarding you a\n";
							print MAIL "Blue Ribbon.\n\n";
						}

						print MAIL "This award will be shown everywhere on the Jet Grind Radio Web Site\n";
						print MAIL "with the exception of Chat.  Next to your name, on any entry in\n";
						print MAIL "World Rankings, all of your awards will be displayed.\n\n";

						print MAIL "We are very proud of you.\n\n";

						print MAIL "Yours truly,\n\n";

						print MAIL "Sonic Team\n";
						print MAIL "sonicteam\@sonic-adventure.com\n\n";

						# if ($row[$dc->UserOff('MEDAL')] < 130)
						# {
							# print MAIL "P.S.  Be sure to try for the Emblem Award!  You are granted this award if\n";
							# print MAIL "you have all 130 emblems!\n";
						# }

						close(MAIL);
					}
					else
					{
						$dc->error("Unable to send e-mail to ".$dc->q->param('mailid').".", $errorURL);
					}
				}

				if ($IN::medal >= 0)
				{
					# Update user table information
					
					($errN, $errstr)       = DB::modifyRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $row[$dc->UserOff('USERID')], $row[$dc->UserOff('EMAIL')], $row[$dc->UserOff('NAME')], $row[$dc->UserOff('CITY')], $row[$dc->UserOff('STATE')], $row[$dc->UserOff('COUNTRY')], $row[$dc->UserOff('MFLAG')], $row[$dc->UserOff('ADMIN')], $gold, $silver,$bronze,$ribbon, time );
					if ($errN)
					{
						$dc->error("[admin_wrank] Unable to update user info: $errN .... $errstr", $errorURL);
					}
				}

				DB::closeOracleConnection( $dbh );
				
				# Display Record
				&output_verify($key);
			}
		}
	}

exit(0);

#--------------------------------------------------------
# Data Check
#--------------------------------------------------------
sub check_data
{
	my $MAIL = "";
    my $Warning = "";
	my ($dbh, $errN, $errstr, @row, $key, $val);

    $Mode = $IN::MODE;
    $Track = $IN::STAGE;
    if(!defined($StageName[$Track])) {
        $dc->error("Invalid stage was chosen.<BR>Please select a different track.", $errorURL);
    }
 
	$dc->q->param('GameType', $GameType[$Mode]);
	$dc->q->param('TrackFile', $TimeTbl[($Track * ($Mode * 6))]->[0]);
	$dc->q->param('AdxFile', $TimeTbl[($Track * ($Mode * 6))]->[1]);
	$dc->q->param('VMUFile', $TimeTbl[($Track * ($Mode * 6))]->[2]);
	$EventID = ($Track * 1000) + $Mode;
	$dc->q->param('EventID', $EventID);

	# Key Acquisition
	$MAIL = $dc->q->param('mailid');
	$MAIL =~ y/A-Z/a-z/;
	$dc->q->param('mailid', $MAIL);
	if($MAIL eq "" || $MAIL =~ /[^a-z0-9_\-\.\@]/) {
		$dc->error("Something wrong with E-mail address \"$MAIL\".<BR>Please make sure there are no spaces at the end of your E-mail address.", $errorURL);
	}
}

#--------------------------------------------------------
# Result Output
#--------------------------------------------------------
sub output_verify {
	my $UserKey = shift;

	my ($dbh, $errN, $errstr, @row, $loop);

	($dbh, $errstr) = DB::openOracleConnection();
	if( !$dbh )
	{
		$dc->error("[admin_wrank] Error connecting to database: $errstr");
	}

	($errN, $errstr, @row) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $UserKey );
	if ($errN)
	{
		$dc->error("[admin_wrank] Fetching user key: $errN .... $errstr", $errorURL);
	}
				
	DB::closeOracleConnection( $dbh );
	
	if ($UserKey eq $row[$dc->UserOff('KEY')])
	{
		#User is defined in database
		print "Content-type: text/html\n\n";
		print <<EOF;

<html>
<head>
<title>
Sonic Adventure Online - World Ranking Validation
</title>
<meta name="x-uirequest" content="urlbaroff">
</head>
<body x-marginleft=0 x-margintop=0   background="file:/bg_scroller.gif" bgcolor="#000000" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0>
<center>
<img src="file:/blank_dot.gif" width=1 height=30 border=0 alt=""><br>
<table cellspacing=0 cellpadding=5 border=0 width=590><tr><td align=center valign=top bgcolor="#000033"><table cellspacing=0 cellpadding=0 border=0 width=580><tr><td align=left valign=top bgcolor="#ffffff">

<!-- HEADER IMAGE -->
<!-- choose from below... -->
<!-- header_chao_showoff.gif -->
<!-- header_events.gif -->
<!-- header_world_rankings.gif -->

<img src="file:/header_world_rankings.gif" width=580 height=150 border=0 alt=""><br>

<!-- END HEADER IMAGE -->

<table cellspacing=0 cellpadding=0 border=0 width=580><tr><td align=left valign=top width="10">
<img src="file:/blank_dot.gif" width=10 height=1 border=0 alt="">
</td>
<td align=left valign=top width=560>

<!-- BEGIN CONTENT HERE -->

<CENTER>
<TABLE border=1 cellpadding=5 cellspacing=0 width=560 BGCOLOR="#CCCCCC">
<TR>
<TD height="60" align="left" colspan=2 BGCOLOR="#666666">
DISPLAY USER INFORMATION
</TD>
</TR>
<TR>
<TD WIDTH="140">Name:</TD>
<TD>$row[$dc->UserOff('NAME')]</TD>
</TR>

<TR>
<TD>E-Mail:</TD>
<TD>$row[$dc->UserOff('EMAIL')]</TD>
</TR>

<TR>
<TD>
EOF
		if ($dc->Flags($row[$dc->UserOff('COUNTRY')]) ne "")
		{
			print "<img src=\"/images/flags/".$dc->Flags($row[$dc->UserOff('COUNTRY')])."\" width=40 height=20 border=0 align=\"right\">";	
		} else {
			# Draw the generic flag
			print "<img src=\"/images/flags/flag_other.gif\" width=40 height=20 border=0 align=\"right\">";
		}
		print "Location:</TD><TD>\n";

        print "$row[$dc->UserOff('CITY')], ";
		if ($row[$dc->UserOff('STATE')] ne "") {
			printf "%s, ", $dc->state_name($row[$dc->UserOff('STATE')]);
		}
		printf "%s\n", $dc->country_name($row[$dc->UserOff('COUNTRY')]);

    print <<EOF;
</TD></TR>

<TR>
<TD VALIGN="TOP" COLSPAN="2">Awards:<BR>
EOF
		my $count = 0;
		for ($loop = 0; $loop < $row[$dc->UserOff('GOLD')]; ++$loop)
		{
			print "<img src=\"/images/wrank/can_gold.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
			++$count;
			if ($count >= 8)
			{
				print "<BR>\n";
				$count = 0;
			}
		}

		for ($loop = 0; $loop < $row[$dc->UserOff('SILVER')]; ++$loop)
		{
			print "<img src=\"/images/wrank/can_silver.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
			++$count;
			if ($count >= 8)
			{
				print "<BR>\n";
				$count = 0;
			}
		}

		for ($loop = 0; $loop < $row[$dc->UserOff('BRONZE')]; ++$loop)
		{
			print "<img src=\"/images/wrank/can_bronze.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
			++$count;
			if ($count >= 8)
			{
				print "<BR>\n";
				$count = 0;
			}
		}

		for ($loop = 0; $loop < $row[$dc->UserOff('BLUERIB')]; ++$loop)
		{
			print "<img src=\"/images/wrank/ribbon_big.gif\" width=50 height=50 border=0 hspace=5 align=\"top\">";
			++$count;
			if ($count >= 8)
			{
				print "<BR>\n";
				$count = 0;
			}
		}

	print <<EOF;
</TD>
</TR>

</TABLE>
</CENTER>

<!-- END CONTENT HERE -->
&nbsp;<br>
<a href="/cgi-bin/jetgrindradio/admin/showhtml.cgi?page=admin_wrank.html"><img src="/images/button_back.gif" width=81 height=24 border=0 alt="" name="img1"></a><P>				
</td><td align=left valign=top width="10">
<img src="/images/blank_dot.gif" width=10 height=1 border=0 alt="">
</td>
</tr>
</table>
</tr>
</tr>
</table>
</td>
</tr>
</table>
<br>&nbsp;
</center>
</body>
</html>
EOF
	}
	else
	{
		$dc->error("[admin_wrank] User not found in database.\n", $errorURL);
	}
}

#------------------------ EOF --------------------------
