#
# Rush 2049
# Common Defines for Rush 2049 CGI
#

#

######################################################
# Which flags should be displayed for each country
######################################################
%Flags = (  'US', 'flag_us.gif',
			'JP', 'flag_jp.gif',
			'GB', 'flag_england.gif',
			'BE', 'flag_belgium.gif',
			'BR', 'flag_brazil.gif',
			'CA', 'flag_canada.gif',
			'FI', 'flag_finland.gif',
			'FR', 'flag_france.gif',
			'FX', 'flag_france.gif',
			'DE', 'flag_germany.gif',
			'HK', 'flag_hk.gif',
			'IE', 'flag_ireland.gif',
			'IT', 'flag_italy.gif',
			'LU', 'flag_luxembourg.gif',
			'NL', 'flag_netherlands.gif',
			'AN', 'flag_netherlands.gif',
			'NO', 'flag_norway.gif',
			'PT', 'flag_portugal.gif',
			'SG', 'flag_singapore.gif',
			'ES', 'flag_spain.gif',
			'SE', 'flag_sweden.gif',
			'CH', 'flag_switzerland.gif',
			'TW', 'flag_taiwan.gif',
		);

@KanjiCodeText = (
	# Double Characters with "ya"
	[ 0x70, 0xA6, "KYA" ],
	[ 0x71, 0xA6, "GYA" ],
	[ 0x7A, 0xA6, "SHA" ],
	[ 0x7B, 0xA6, "JA" ],
	[ 0x84, 0xA6, "CHA" ],
	[ 0x85, 0xA6, "JA" ],
	[ 0x8E, 0xA6, "NYA" ],
	[ 0x95, 0xA6, "HYA" ],
	[ 0x96, 0xA6, "BYA" ],
	[ 0x97, 0xA6, "PYA" ],
	[ 0xA2, 0xA6, "MYA" ],
	[ 0xAD, 0xA6, "RYA" ],

	# Double Characters with "yu"
	[ 0x70, 0xA8, "KYU" ],
	[ 0x71, 0xA8, "GYU" ],
	[ 0x7A, 0xA8, "SHU" ],
	[ 0x7B, 0xA8, "JU" ],
	[ 0x84, 0xA8, "CHU" ],
	[ 0x85, 0xA8, "JU" ],
	[ 0x89, 0xA8, "TU" ],
	[ 0x8A, 0xA8, "DO" ],
	[ 0x8E, 0xA8, "NYU" ],
	[ 0x95, 0xA8, "HYU" ],
	[ 0x96, 0xA8, "BYU" ],
	[ 0x97, 0xA8, "PYU" ],
	[ 0xA2, 0xA8, "MYU" ],
	[ 0xAD, 0xA8, "RYU" ],

	# Double Characters with "yo"
	[ 0x70, 0xAA, "KYO" ],
	[ 0x71, 0xAA, "GYO" ],
	[ 0x7A, 0xAA, "SHO" ],
	[ 0x7B, 0xAA, "JO" ],
	[ 0x84, 0xAA, "CHO" ],
	[ 0x85, 0xAA, "JO" ],
	[ 0x8E, 0xAA, "NYO" ],
	[ 0x95, 0xAA, "HYO" ],
	[ 0x96, 0xAA, "BYO" ],
	[ 0x97, 0xAA, "PYO" ],
	[ 0xA2, 0xAA, "MYO" ],
	[ 0xAD, 0xAA, "RYO" ],

	# Double Characters with little vowels
	[ 0x69, 0x66, "WI" ],
	[ 0x69, 0x6A, "WE" ],
	[ 0x89, 0x66, "TI" ],
	[ 0x8B, 0x68, "TO" ],
	[ 0x98, 0x64, "FA" ],
	[ 0x98, 0x66, "FI" ],
	[ 0x98, 0x6A, "FE" ],
	[ 0x98, 0x6C, "FO" ],

	# Double Characters starting with "tsu"
	[ 0x86, 0x6E, "KKA" ],
	[ 0x86, 0x70, "KKI" ],
	[ 0x86, 0x72, "KKU" ],
	[ 0x86, 0x74, "KKE" ],
	[ 0x86, 0x76, "KKO" ],
	[ 0x86, 0x78, "SSA" ],
	[ 0x86, 0x7A, "SSHI" ],
	[ 0x86, 0x7C, "SSU" ],
	[ 0x86, 0x7E, "SSE" ],
	[ 0x86, 0x80, "SSO" ],
	[ 0x86, 0x82, "TTA" ],
	[ 0x86, 0x84, "CCHI" ],
	[ 0x86, 0x87, "TTSU" ],
	[ 0x86, 0x89, "TTE" ],
	[ 0x86, 0x8B, "TTO" ],
	[ 0x86, 0x92, "HHA" ],
	[ 0x86, 0x95, "HHI" ],
	[ 0x86, 0x98, "FFU" ],
	[ 0x86, 0x9B, "HHE" ],
	[ 0x86, 0x9E, "HHO" ],
	[ 0x86, 0xA1, "MMA" ],
	[ 0x86, 0xA2, "MMI" ],
	[ 0x86, 0xA3, "MMU" ],
	[ 0x86, 0xA4, "MME" ],
	[ 0x86, 0xA5, "MMO" ],
	[ 0x86, 0xA7, "YYA" ],
	[ 0x86, 0xA9, "YYU" ],
	[ 0x86, 0xAB, "YYO" ],
	[ 0x86, 0xAC, "RRA" ],
	[ 0x86, 0xAD, "RRI" ],
	[ 0x86, 0xAE, "RRU" ],
	[ 0x86, 0xAF, "RRE" ],
	[ 0x86, 0xB0, "RRO" ],
	[ 0x86, 0xB2, "WWA" ],
	[ 0x86, 0xB5, "WWO" ],

	# Double Characters starting with "tsu" with " Modifier
	[ 0x86, 0x6F, "GGA" ],
	[ 0x86, 0x71, "GGI" ],
	[ 0x86, 0x73, "GGU" ],
	[ 0x86, 0x75, "GGE" ],
	[ 0x86, 0x77, "GGO" ],
	[ 0x86, 0x79, "ZZA" ],
	[ 0x86, 0x7B, "JJI" ],
	[ 0x86, 0x7D, "ZZU" ],
	[ 0x86, 0x7F, "ZZE" ],
	[ 0x86, 0x81, "ZZO" ],
	[ 0x86, 0x83, "DDA" ],
	[ 0x86, 0x85, "JJI" ],
	[ 0x86, 0x88, "ZZU" ],
	[ 0x86, 0x8A, "DDE" ],
	[ 0x86, 0x8C, "DDO" ],
	[ 0x86, 0x93, "BBA" ],
	[ 0x86, 0x96, "BBI" ],
	[ 0x86, 0x99, "BBU" ],
	[ 0x86, 0x9C, "BBE" ],
	[ 0x86, 0x9F, "BBO" ],

	# Double Characters starting with "tsu" with o Modifier
	[ 0x86, 0x94, "PPA" ],
	[ 0x86, 0x97, "PPI" ],
	[ 0x86, 0x9A, "PPU" ],
	[ 0x86, 0x9D, "PPE" ],
	[ 0x86, 0xA0, "PPO" ],

	# Single Characters
	[ 0x65, 0x00, "A" ],
	[ 0x67, 0x00, "I" ],
	[ 0x69, 0x00, "U" ],
	[ 0x6B, 0x00, "E" ],
	[ 0x6D, 0x00, "O" ],
	[ 0x6E, 0x00, "KA" ],
	[ 0x70, 0x00, "KI" ],
	[ 0x72, 0x00, "KU" ],
	[ 0x74, 0x00, "KE" ],
	[ 0x76, 0x00, "KO" ],
	[ 0x78, 0x00, "SA" ],
	[ 0x7A, 0x00, "SHI" ],
	[ 0x7C, 0x00, "SU" ],
	[ 0x7E, 0x00, "SE" ],
	[ 0x80, 0x00, "SO" ],
	[ 0x82, 0x00, "TA" ],
	[ 0x84, 0x00, "CHI" ],
	[ 0x87, 0x00, "TSU" ],
	[ 0x89, 0x00, "TE" ],
	[ 0x8B, 0x00, "TO" ],
	[ 0x8D, 0x00, "NA" ],
	[ 0x8E, 0x00, "NI" ],
	[ 0x8F, 0x00, "NU" ],
	[ 0x90, 0x00, "NE" ],
	[ 0x91, 0x00, "NO" ],
	[ 0x92, 0x00, "HA" ],
	[ 0x95, 0x00, "HI" ],
	[ 0x98, 0x00, "FU" ],
	[ 0x9B, 0x00, "HE" ],
	[ 0x9E, 0x00, "HO" ],
	[ 0xA1, 0x00, "MA" ],
	[ 0xA2, 0x00, "MI" ],
	[ 0xA3, 0x00, "MU" ],
	[ 0xA4, 0x00, "ME" ],
	[ 0xA5, 0x00, "MO" ],
	[ 0xA7, 0x00, "YA" ],
	[ 0xA9, 0x00, "YU" ],
	[ 0xAB, 0x00, "YO" ],
	[ 0xAC, 0x00, "RA" ],
	[ 0xAD, 0x00, "RI" ],
	[ 0xAE, 0x00, "RU" ],
	[ 0xAF, 0x00, "RE" ],
	[ 0xB0, 0x00, "RO" ],
	[ 0xB2, 0x00, "WA" ],
	[ 0xB5, 0x00, "WO" ],
	[ 0xB6, 0x00, "N" ],
	[ 0x64, 0x00, "A" ],
	[ 0x66, 0x00, "I" ],
	[ 0x68, 0x00, "U" ],
	[ 0x6A, 0x00, "E" ],
	[ 0x6C, 0x00, "O" ],

	# " Modifier to Single Lists
	[ 0x6F, 0x00, "GA" ],
	[ 0x71, 0x00, "GI" ],
	[ 0x73, 0x00, "GU" ],
	[ 0x75, 0x00, "GE" ],
	[ 0x77, 0x00, "GO" ],
	[ 0x79, 0x00, "ZA" ],
	[ 0x7B, 0x00, "JI" ],
	[ 0x7D, 0x00, "ZU" ],
	[ 0x7F, 0x00, "ZE" ],
	[ 0x81, 0x00, "ZO" ],
	[ 0x83, 0x00, "DA" ],
	[ 0x85, 0x00, "JI" ],
	[ 0x88, 0x00, "ZU" ],
	[ 0x8A, 0x00, "DE" ],
	[ 0x8C, 0x00, "DO" ],
	[ 0x93, 0x00, "BA" ],
	[ 0x96, 0x00, "BI" ],
	[ 0x99, 0x00, "BU" ],
	[ 0x9C, 0x00, "BE" ],
	[ 0x9F, 0x00, "BO" ],

	# o Modifier to Single Lists
	[ 0x94, 0x00, "PA" ],
	[ 0x97, 0x00, "PI" ],
	[ 0x9A, 0x00, "PU" ],
	[ 0x9D, 0x00, "PE" ],
	[ 0xA0, 0x00, "PO" ],

	# End of list
	[ 0x00, 0x00, "" ]
	);

######################################################
# Table names for each database
######################################################
%DBaseTable = (
	# User Table
	'USER' => "jetgrindradio_user",

	# World Ranking
	'WRANK' => "jetgrindradio_wrank",

	# Graffiti
	'GRAFFITI' => "jetgrindradio_graffiti",

	#Special Administrator User - Illegal e-mail values to prevent unauthorized use
	'ADMIN' => "[%ADMIN USER*]",
	);

######################################################
# Use for index into user data returned from Oracle
######################################################
%UserOff = (
		'USERID',	0,		# Product ID of Game
		'EMAIL',	1,		# E-mail address of user
		'NAME',		2,		# User Name
		'CITY',		3,		# City
		'STATE',	4,		# State
		'COUNTRY',	5,		# Country
		'MFLAG',	6,		# If want e-mail shown
		'ADMIN',	7,		# If user has administration rights for graffiti rankings
		'GOLD',		8,		# Number of Gold Medals
		'SILVER',	9,		# Number of Silver Medals
		'BRONZE',	10,		# Number of Bronze Medals
		'BLUERIB',	11,		# Number of Blue Ribbons
		'CDATE',	12,		# Creation Date of User Account
		'MDATE',	13,		# Modified Data of User Account
	);

######################################################
# Use for index into World Ranking data returned from Oracle
######################################################
%WRankOff = (
		'KEY',		0,		# User ID Key
		'EVENTID',	1,		# Event ID Number (Unique per event)
		'MODE',		2,		# Which Game Mode (Story, Crush, Tech, or Graffiti)
		'STAGE',	3,		# Which City
		'CHAR',		4,		# Which Character was used
		'RANK',		5,		# How well the level was completed
		'SCORE',	6,		# Points or time that was scored
		'COMMENT',	7,		# User Comment
		'MDATE',	8,		# Modified Date
		);

######################################################
# Use for index into Graffiti data returned from Oracle
######################################################
%GraffitiOff = (
		'KEY',			0,		# Unique Key (Unique)
		'USERID',		1,		# User ID Number 
		'SIZE',			2,		# Size of Graffiti (Small, Large, or Extra-Large)
		'TITLE',		3,		# Graffiti Title
		'DESC',			4,		# Graffiti Description
		'COMMENT',		5,		# User Comment
		'DLCOUNT',		6,		# # of times Downloaded
		'RANKTOTAL',	7,		# Rank Total
		'RANKCNT',		8,		# Number of Users Voted
		'CURRANK',		9,		# Current Rank
		'PENDING',		10,		# If Graffiti is waiting for approval
		'ADMINID',		11,		# Admin User ID Number
		'CDATE',		12,		# Creation Date
		'ADATE',		13,		# Approval Date
		'VMS',			14,		# VMU Graffiti Data
		);

#------------------------ EOF --------------------------
1;

