#!/usr/bin/perl -I.
# Dreamcast Version
# Jet Grind Radio
# Graffiti VMU Download Data
# 


use strict;

use CGI;
use	DC;
use DB;


## Set up variables
use vars	(	'$dc',	# DC object
				'@IN',
				'$errorURL',
				'$vmsurl',
				'$vmsdir',
				'$vmsfname',
				'$browserid',
			);

#...............................................

# Required parameter
# 1. UniqKey	= Unique Identifier for the graffiti piece that will be DLed.

	my $q = new CGI;
	$dc = new DC($q);
	$dc->q->import_names('IN');
	$browserid = -1;

	$errorURL = "graffiti.html";
	$vmsurl = 'http://jetgrindradio.web.dreamcast.com/tmp';
	$vmsdir = '../../tmp';
	my $fileid = sprintf "%08d", $$;

	my ($errN, $errstr, $dbh, $sth, @row);

    &check_data;

	($dbh, $errstr) = DB::openOracleConnection();
	if( !$dbh )
	{
		$dc->error("[getgraffiti] Error connecting to database: $errstr", $errorURL);
	}

    ($errN, $errstr, $sth) = DB::getRow_GraffitiByUK( $dbh, $dc->DBaseTable('GRAFFITI'), $IN::UniqKey );
	if ($errN)
	{
		$dc->error("[getgraffiti] Fetching Graffiti info: $errN .... $errstr", $errorURL);
	}
	else
	{
		(@row) = DB::getNextRow_Graffiti($sth);
		if (@row eq "")
		{
			$dc->error("[getgraffiti] Graffiti Unique Key does not exist", $errorURL);
		}
	}

	# Update the Download Count
	($errN, $errstr)       = DB::modifyCountRow_GraffitiByUK( $dbh, $dc->DBaseTable('GRAFFITI'), $IN::UniqKey, ($row[$dc->GraffitiOff('DLCOUNT')] + 1), $row[$dc->GraffitiOff('RANKTOTAL')], $row[$dc->GraffitiOff('RANKCNT')], $row[$dc->GraffitiOff('CURRANK')] );
	if ($errN)
	{
		$dc->error("[getgraffiti] Updating Download Count: $errN .... $errstr", $errorURL);
	}

	DB::closeOracleConnection( $dbh );

	# Make First VMI File
	if ($row[$dc->GraffitiOff('SIZE')] == 0)
	{
		$vmsfname = "JETGRIND_S00";
	}
	elsif ($row[$dc->GraffitiOff('SIZE')] == 1)
	{
		$vmsfname = "JETGRIND_L00";
	}
	elsif ($row[$dc->GraffitiOff('SIZE')] == 2)
	{
		$vmsfname = "JETGRIND_X00";
	}
	else
	{
		$dc->error("[getgraffiti] Improper Graffiti size has been selected, and can't be saved.", $errorURL);
	}

	make_vmsfile($fileid, $row[$dc->GraffitiOff('VMS')], $vmsfname);

    # Send Graffiti Data
	my $location = "${vmsurl}/${fileid}.VMI";
	print $dc->q->redirect(-location=>$location);

exit(0);

#--------------------------------------------------------
# Data Check
#--------------------------------------------------------
sub check_data {
    if($IN::UniqKey eq "") {
        $dc->error("[getgraffiti] Invalid unique key was given \"$IN::UniqKey\".", $errorURL);
    }

	if ($dc->q->referer() !~ m(^http://jetgrindradio\.web\.dreamcast\.com/))
	{
		$dc->error("[getgraffiti] File request denied.<BR>Only authorized URLs allowed.", $errorURL);
	}

	$browserid = $dc->get_browser();
	if ($browserid == -1)
	{
		$dc->error("[getgraffiti] File request denied.<BR>Only authorized browsers allowed.", $errorURL);
	}
}

#--------------------------------------------------------
# Cancel Unnecessary VMS Files
#--------------------------------------------------------
sub del_vmsfile {
	my $filename = shift;

	unlink("${vmsdir}/${filename}.VMI");
	unlink("${vmsdir}/${filename}.VMS");
}

#--------------------------------------------------------
# Create the VMS files for download
#--------------------------------------------------------
sub make_vmsfile {
	my $filename = shift;
	my $GRAFFITI = shift;
	my $VMUNAME = shift;

	# Clear out old VMS and VMI files sitting on the system
	&del_vmsfile($filename);

	# Create the VMS file
    if(open(VMSFILE,">${vmsdir}/${filename}.VMS")) {
        print VMSFILE $GRAFFITI;
        close(VMSFILE);
        chmod(0666,"${vmsdir}/${filename}.VMS");
    } else {
        $dc->error("[getgraffiti] Failure to create VMS file \"${filename}\".", $errorURL);
    }

	# Create the VMI file
    if(open(VMIFILE,">${vmsdir}/${filename}.VMI")) {
		my $vmidata = "";

        $vmidata = $dc->make_vmidata($filename, length($GRAFFITI), $VMUNAME);
        print VMIFILE $vmidata;

        close(VMIFILE);
        chmod(0666,"${vmsdir}/${filename}.VMI");
    } else {
        $dc->error("[getgraffiti] Failure to create VMI file \"${filename}\".", $errorURL);
    }

}

#------------------------ EOF --------------------------

