#!/usr/bin/perl -I.
# Dreamcast Version
# Rush 2049
# World Rankings Displayer
# 


use strict;

use CGI;
use	DC;
use POSIX	'strftime';
use DB;

## Set up variables
use vars	(	'$dc',	# DC object
				'@IN', '@BINDATA', '$PDATA', '$WRANK', '@oldDATA', '$allrank', '$todayrank',
				'$errorURL', '$cgiPath', '$date', '$cookieDate',
				'$Type', '$type', '$EventID', '$Score', '$Char', '$Rank', '$Stage', '$Mode', '$contest',
				'@StageName', '@GameType', '@LevelName', '@StageTbl', '@CharactersTbl', '@RankTbl', '@BackList',
				'$MAX', '$START', '$END', '$UserKey', '$MaxRec', '$nextflag',
			);


$MAX = 10;			# Default number of menu choices

@StageName = ( 'Shibuya-Cho',
               'Kogane-Cho',
               'Benten-Cho',
               'Bantam Street',
               'Grind Square',
             );

@GameType = (  'Story',
			   'Jet Crush',
               'Jet Technique',
               'Jet Graffiti',
             );

@LevelName = ('Shibuya GG','Love Trap','Love Attack','Explosion','',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'The Monster of Kogane','No. 540','Kogane Circus','Fight or Flight','',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'Benten Boogie','Graffiti High','Noise Reduction','Benten Burning','Behind the Mask',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'Tag or Die','','','','',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'Rock\' N Roll Grind','','','','',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			 );

# Stage Related Data
@StageTbl = (
		# key => [ Stage Name, Stage Graphic, VMU File ]
		[ "/images/maptext_shibuya.gif", "/images/maps_shibuya.gif", "JETGRIND_SYS"],
		[ "/images/maptext_kogane.gif", "/images/maps_kogane.gif", "JETGRIND_SYS"],
		[ "/images/maptext_benten.gif", "/images/maps_benten.gif", "JETGRIND_SYS"],
		[ "/images/maptext_bantam.gif", "/images/maps_bantam.gif", "JETGRIND_SYS"],
		[ "/images/maptext_grindsq.gif", "/images/maps_grindsq.gif", "JETGRIND_SYS"],
        );

@CharactersTbl = (
				# key => [ Character Name, Character Graphic, Hex Value ]
				[ "Beat",			"/images/char_beat.gif",	"0" ],
				[ "Gum",			"/images/char_gum.gif",		"1" ],
				[ "Tab",			"/images/char_tab.gif",		"2" ],
				[ "Combo",			"/images/char_combo.gif",	"3" ],
				[ "Slate",			"/images/char_slate.gif",	"4" ],
				[ "Piranha",		"/images/char_piranha.gif",	"5" ],
				[ "Cube",			"/images/char_cube.gif",	"6" ],
				[ "Mew",			"/images/char_mew.gif",		"7" ],
				[ "Yo-Yo",			"/images/char_yoyo.gif",	"8" ],
				[ "Garam",			"/images/char_garam.gif",	"9" ],
				[ "Poison Jam",		"/images/char_poison.gif",	"A" ],
				[ "Love Shocker",	"/images/char_love.gif",	"B" ],
				[ "Noise Tanks",	"/images/char_noise.gif",	"C" ],
				[ "Goji",			"/images/char_goji.gif",	"D" ],
				[ "Pots",			"/images/char_pots.gif",	"E" ],
				);

@RankTbl = (
			# key => [ Class Name, Class Graphic ]
			[ "Pedal!",		"/images/rank_pedal.gif" ],
			[ "Motor!",		"/images/rank_motor.gif" ],
			[ "Engine!",	"/images/rank_engine.gif" ],
			[ "Turbo!",		"/images/rank_turbo.gif" ],
			[ "Nitro!",		"/images/rank_nitro.gif" ],
			[ "Jet!",		"/images/rank_jet.gif" ],
		 );

@BackList = (
				"/rank_shibuya.html",
				"/rank_shibuyastory.html",
				"/rank_kogane.html",
				"/rank_koganestory.html",
				"/rank_benten.html",
				"/rank_bentenstory.html",
				"/rank_bantam.html",
				"/rank_bantamstory.html",
				"/rank_grindsq.html",
				"/rank_grindsqstory.html",
			);


# Handling time
	$date = strftime("UPLOADED ON %m/%d/%Y, %I:%M %p (%Z)", localtime);
	$cookieDate = strftime("Date: %a, %d %b %Y %H:%M:%S %Z", gmtime);

	my $q = new CGI;
	$dc = new DC($q);
	$dc->q->import_names('IN');

	$errorURL = "rank.html";
	$cgiPath = "/cgi-bin/jetgrindradio/score.cgi";

	my $userid = $dc->q->cookie(-name=>'login_userID');

	@BINDATA = ();
	$PDATA = "";
	$WRANK = "";
	$nextflag = 1;
	$Type = 0;

	if($dc->q->param('command') eq "")
	{
		&check_data(1);		# First time through
	} else {
		&check_data(0);
	}
   
    if(($Type >= 0) && ($Type <= 4)) {
		if ($dc->q->param('command') eq 'menu')
		{
			my $cookie = $dc->q->cookie(-name => 'world_ranking',
									-value   => [$dc->q->param('STAGE'),
												 $dc->q->param('MODE')],
									-expires => '+7d',
									-path    => '/');

			print "Set-Cookie: ".$cookie."\n";

			print $cookieDate."\n";

			# Cache control does not work with DreamKey
#			print "Cache-control: no-cache\n\n";

			$dc->q->param('backURL', @BackList[(($Stage * 2) + (($Type == 0) ? 1 : 0))]);

			# Menu template
			if ($contest == 0)
			{
				$dc->output_form("html/rank_menu.html");
			}
			elsif ($contest == 1)
			{
				$dc->output_form("html/rank_menu_pending.html");
			}
			elsif ($contest == 2)
			{
				$dc->output_form("html/rank_menu_winners.html");
			}
			else
			{
				$dc->output_form("html/rank_menu_closed.html");
			}
		} elsif($dc->q->param('command') eq 'form') {
			# Form output again
			$dc->output_form("html/rank_form.html");
		} elsif($dc->q->param('command') eq "") {
			# Form output again
			$dc->output_form("html/rank_form.html");
		} elsif ($dc->q->param('command') eq 'search') {
			&check_search;
			# Form output again
			$dc->output_form("html/rank_search.html");
		} elsif ($dc->q->param('command') eq 'view') {
			&check_search;
			&output_records(&read_data());
		} elsif ($dc->q->param('command') eq 'verify') {
			# Record data into Database
			my ($dbh, $errN, $errstr, @row, $key);
			
			# Check to make sure that Login returned a valid userID
			if ($userid eq "")
			{
				$dc->error("[score] Error logging in.  Please try again.", "/home.html");
			}

			# Read user information from the table
			$key = $dc->make_key($userid);
			
			($dbh, $errstr) = DB::openOracleConnection();
			if( !$dbh )
			{
				$dc->error("[score] Error connecting to database: $errstr");
			}
			
			# Update user table information
			($errN, $errstr, @row) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $key );
			if ($errN)
			{
				$dc->error("[score] Fetching user key: $errN .... $errstr", $errorURL);
			}
				
			($errN, $errstr)       = DB::modifyRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $key, $row[$dc->UserOff('EMAIL')], $row[$dc->UserOff('NAME')], $row[$dc->UserOff('CITY')], $row[$dc->UserOff('STATE')], $row[$dc->UserOff('COUNTRY')], $dc->q->param('MAIL'), $row[$dc->UserOff('ADMIN')], $row[$dc->UserOff('GOLD')], $row[$dc->UserOff('SILVER')], $row[$dc->UserOff('BRONZE')], $row[$dc->UserOff('BLUERIB')], time );
			if ($errN)
			{
				$dc->error("[score] Unable to update user info: $errN .... $errstr", $errorURL);
			}
				
			DB::closeOracleConnection( $dbh );

			# Enter the data into the World Ranking Database
			my $added = new_record($userid, $EventID);

			$allrank = determine_rank($userid, $EventID, "ALL");
			$todayrank = determine_rank($userid, $EventID, "TODAY");

			# Display Record
			&output_verify($added);
		} elsif ($dc->q->param('command') eq 'login') {
			my ($username, $userid, $email, $city, $state, $country, $location);

			$userid   = substr($IN::userid, 0, (length($IN::userid) - 2));
			$username = substr($IN::username, 0, (length($IN::username) - 2));
			$email    = substr($IN::email, 0, (length($IN::email) - 2));
			$city     = $dc->smut_check(substr($IN::city, 0, (length($IN::city) - 2)));
			$state    = substr($IN::state, 0, (length($IN::state) - 2));
			$country  = substr($IN::country, 0, (length($IN::country) - 2));

			if ($email eq "null")
			{
				$email = "";
			}
			if ($city eq "null")
			{
				$city = "";
			}
			if ($state eq "null")
			{
				$state = "";
			}
			if ($country eq "null")
			{
				$country = "";
			}

			# Throw away data if too large for database
			if (length($state) > 2)
			{
				$state = "";
			}
			if (length($country) > 2)
			{
				$country = "";
			}

			# Record data into Database
			my ($dbh, $errN, $errstr, @row, $key);
			
			# Check to make sure that Login returned a valid userID
			if ($userid eq "")
			{
				$dc->error("[score] Error logging in.  Please try again.", "index.html");
			}

			# Read user information from the table
			$key = $dc->make_key($userid);
			
			($dbh, $errstr) = DB::openOracleConnection();
			if( !$dbh )
			{
				$dc->error("[score] Error connecting to database: $errstr");
			}
			
			# Update user table information
			($errN, $errstr, @row) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $key );
			if ($errN)
			{
				$dc->error("[score] Fetching user key: $errN .... $errstr", $errorURL);
			}
				
			($errN, $errstr)       = DB::modifyRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $key, $email, $username, $city, $state, $country, $row[$dc->UserOff('MFLAG')], $row[$dc->UserOff('ADMIN')], $row[$dc->UserOff('GOLD')], $row[$dc->UserOff('SILVER')], $row[$dc->UserOff('BRONZE')], $row[$dc->UserOff('BLUERIB')], time );
			if ($errN)
			{
				$dc->error("[score] Unable to update user info: $errN .... $errstr", $errorURL);
			}
				
			DB::closeOracleConnection( $dbh );


			# Set up variables to be used in outputted page
			$dc->q->param('username', $username);
			$dc->q->param('email', $email);
			if ($country ne "US")
			{
				$location = $city."<BR>".$dc->country_name($country)."\n";
			}
			else
			{
				$location = $city.", ".$dc->state_name($state)."<BR>".$dc->country_name($country)."\n";
			}
			$dc->q->param('location', $location);

			# Update the Cookie
			####################################################

			# Set Cookie and create record
			my $cookie = $dc->q->cookie(-name => 'login_userID',
										-value   => $key,
										-expires => '+1d',
										-path    => '/');

			print "Set-Cookie: ".$cookie."\n";

			print $cookieDate."\n";

			# Cache control does not work with DreamKey
#			print "Cache-control: no-cache\n\n";

			$dc->output_form("html/login_success.html");
		}
	}

exit(0);

#--------------------------------------------------------
# Data Check
#--------------------------------------------------------
sub check_data
{
	my $first = shift;

	my $MAIL = "";
    my $Warning = "";
	my ($dbh, $errN, $errstr, @row, $key, $val);

	if($dc->q->param('command') eq "")
	{
		my @level = $dc->q->cookie(-name=>'world_ranking');
		if (($level[0] eq "") || ($level[1] eq ""))
		{
			$dc->error("Cookie of \"world_ranking\" has not been set.<BR>Please make sure your Dreamcast clock is correct, or that Cookies are enabled.", $errorURL);
		}

		$dc->q->param('STAGE', $level[0]);
		$dc->q->param('MODE', $level[1]);
	}
	
    $Stage = $dc->q->param('STAGE');
	$Mode = $dc->q->param('MODE');
    if(!defined($StageName[$Stage])) {
        $dc->error("[score] Invalid stage was chosen.<BR>Please select a different stage.", $errorURL);
    }

	# All Modes use only entry "1st" except Story Mode.

	$Type = 0;				# Default to Story Mode
	# Story Mode
    if (($Mode == 0) || ($Mode == 10) || ($Mode == 20) || ($Mode == 30) || ($Mode == 40)) {
		# This mode is not used
		$Type = 0;
		my $val = (($Stage * (4 * 5)) + ($Mode / 10));
        if($LevelName[$val] ne '') {
			$dc->q->param('StageText', $StageTbl[$Stage]->[0]);
			$dc->q->param('StageImg', $StageTbl[$Stage]->[1]);
			$dc->q->param('VMUFile', $StageTbl[$Stage]->[2]);
			$EventID = ($Stage * 1000) + $Mode;
			$dc->q->param('EventID', $EventID);

			$dc->q->param('StageName', $StageName[$Stage]);
			$dc->q->param('LevelName', $LevelName[$val]);
			$dc->q->param('GameType', $GameType[0]);
			$dc->q->param('ScoreType', "Points");
        } else {
            $dc->error("There is no Story Mode in $StageName[$Stage] Level ".(($Mode/10) + 1).".", $errorURL);
        }
    } elsif($Mode == 1) {			# Jet Crush Mode
		$Type = 1;
		my $val = (($Stage * (4 * 5)) + ($Mode * 5));
        if($LevelName[$val] eq '1st') {
			$dc->q->param('StageText', $StageTbl[$Stage]->[0]);
			$dc->q->param('StageImg', $StageTbl[$Stage]->[1]);
			$dc->q->param('VMUFile', $StageTbl[$Stage]->[2]);
			$EventID = ($Stage * 1000) + $Mode;
			$dc->q->param('EventID', $EventID);

			$dc->q->param('StageName', $StageName[$Stage]);
			$dc->q->param('LevelName', "");
			$dc->q->param('GameType', $GameType[$Mode]);
			$dc->q->param('ScoreType', "Time");
        } else {
            $dc->error("[score] There is no $GameType[$Mode] in $StageName[$Stage].", $errorURL);
        }
    } elsif($Mode == 2) {		# Jet Technique Mode
		$Type = 2;
		my $val = (($Stage * (4 * 5)) + ($Mode * 5));
        if($LevelName[$val] eq '1st') {
			$dc->q->param('StageText', $StageTbl[$Stage]->[0]);
			$dc->q->param('StageImg', $StageTbl[$Stage]->[1]);
			$dc->q->param('VMUFile', $StageTbl[$Stage]->[2]);
			$EventID = ($Stage * 1000) + $Mode;
			$dc->q->param('EventID', $EventID);

			$dc->q->param('StageName', $StageName[$Stage]);
			$dc->q->param('LevelName', "");
			$dc->q->param('GameType', $GameType[$Mode]);
			$dc->q->param('ScoreType', "Points");
        } else {
            $dc->error("[score] There is no $GameType[$Mode] in $StageName[$Stage].", $errorURL);
        }
    } elsif($Mode == 3) {	# Jet Graffiti Mode
		$Type = 3;
		my $val = (($Stage * (4 * 5)) + ($Mode * 5));
        if($LevelName[$val] eq '1st') {
			$dc->q->param('StageText', $StageTbl[$Stage]->[0]);
			$dc->q->param('StageImg', $StageTbl[$Stage]->[1]);
			$dc->q->param('VMUFile', $StageTbl[$Stage]->[2]);
			$EventID = ($Stage * 1000) + $Mode;
			$dc->q->param('EventID', $EventID);

			$dc->q->param('StageName', $StageName[$Stage]);
			$dc->q->param('LevelName', "");
			$dc->q->param('GameType', $GameType[$Mode]);
			$dc->q->param('ScoreType', "Points");
        } else {
            $dc->error("[score] There is no $GameType[$Mode] in $StageName[$Stage].", $errorURL);
        }
	}
	else
	{
		$dc->error("[score] $Mode is an invalid Mode Number.", $errorURL);
	}

	
	# Now that the stage has been verified, it now needs to check to see if it live.
	my $adminkey = $dc->get_key($dc->DBaseTable('ADMIN'));

	($dbh, $errstr) = DB::openOracleConnection();
	if( !$dbh )
	{
		$dc->error("[score] Error connecting to database: $errstr");
	}

	# Read the current contest controlling entry in the database
	($errN, $errstr, @row) = DB::getRow_WRankByUKandEVENT( $dbh, $dc->DBaseTable('WRANK'), $adminkey, $EventID );
	if ($errN)
	{
		$dc->error("[score] Fetching WRank Event Info #$EventID: $errN .... $errstr", $errorURL);
	}
	
	if ($row[$dc->WRankOff('KEY')] eq $adminkey)
	{
		$contest = $row[$dc->WRankOff('SCORE')];
	}
	else
	{
		$contest = -1;
	}
	DB::closeOracleConnection( $dbh );

	# Ensure user isn't trying to enter a contest that is closed or pending
	if ($IN::command eq "")
	{
		if (($contest != 0) && ($contest != 2))
		{
			# Menu template
			if ($contest == 1)
			{
				$dc->output_form("html/rank_menu_pending.html");
				exit(0);
			}
			else
			{
				$dc->output_form("html/rank_menu_closed.html");
				exit(0);
			}
		}
	}
	
	if (($IN::command eq "") || ($IN::command eq "form") || ($IN::command eq "verify"))
	{
		# Don't bother processing if just viewing the World Rankings

		# Data Decode
		
		if( &decode($dc->q->param('bindata')) != 0) {
			$dc->error("Your ranking data was lost.<BR>Please try again and reupload your ranking file.", $errorURL);
		}

		# Distinction between Application Types
		if ($Type == 1)
		{
			if ($Score == 0)
			{
				$Warning .= "You must successfully complete this Jet Crush in order to upload!<BR>";
				$dc->q->param('command', 'form');
			}
		}

		if ($first == 1)
		{
			# Read user information from the table
			if ($userid ne "")
			{
				($dbh, $errstr) = DB::openOracleConnection();
				if( !$dbh )
				{
					$dc->error("[score] Error connecting to database: $errstr", $errorURL);
				}

				($errN, $errstr, @row) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $userid );
				if ($errN)
				{
					$dc->error("[score] Fetching user key: $errN .... $errstr", $errorURL);
				}

				DB::closeOracleConnection( $dbh );

				$dc->q->param('NAME', $row[$dc->UserOff('NAME')]);		# Name
				$dc->q->param('CITY', $row[$dc->UserOff('CITY')]);		# City
				$dc->q->param('STATE', $row[$dc->UserOff('STATE')]);	# State
				$dc->q->param('COUNTRY', $row[$dc->UserOff('COUNTRY')]);# Country
				$dc->q->param('state', $dc->state_name($row[$dc->UserOff('STATE')]));	# State
				$dc->q->param('country', $dc->country_name($row[$dc->UserOff('COUNTRY')]));# Country
				$dc->q->param('MAIL', $row[$dc->UserOff('MFLAG')]);		# Message Flag
			}
			else
			{
				$dc->error("[score] Error - No user has logged on.  Please try again.", "index.html");
			}

			# Set default to No
			if ($dc->q->param('MAIL') ne 'Y')
			{
				$dc->q->param('MAIL', 'N');
			}
		}
		else
		{
			$dc->q->param('NAME', $dc->q->param('NAME'));

			$dc->q->param('CITY', $dc->smut_check($IN::CITY));

			$dc->q->param('STATE', $IN::STATE);

			$dc->q->param('COUNTRY', $IN::COUNTRY);

			$dc->q->param('state', $dc->state_name($IN::STATE));

			$dc->q->param('country', $dc->country_name($IN::COUNTRY));

			if($IN::MAIL eq "Y")
			{
				$dc->q->param('MAIL','Y');
			}
			else
			{
				$dc->q->param('MAIL','N');
			}
		}

		my $trunc = substr($dc->q->param('COMMENT'),0,127);
		$dc->q->param('COMMENT', $dc->smut_check($trunc));

		# Set up the error message
		$dc->q->param('Warning', $Warning);
	}
}

#--------------------------------------------------------
# Additional New Data
#--------------------------------------------------------
sub new_record {
	my $UserKey = shift;
	my $EventID = shift;

	# Record data into Database
	my ($dbh, $errN, $errstr, @row, $newentry, $charIndex);

	# Initially disallow record change					
	$newentry = 0;

	($dbh, $errstr) = DB::openOracleConnection();
	if( !$dbh )
	{
	$dc->error("[score] Error connecting to database: $errstr");
	}

	# Retrieve Awards
	($errN, $errstr, @row) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $UserKey );
	if ($errN)
	{
		$dc->error("[score] Fetching user Info: $errN .... $errstr", $errorURL);
	}
				
	# Key Acquisition
	my $MAIL = $row[$dc->UserOff('EMAIL')];
	$MAIL =~ y/A-Z/a-z/;
	$dc->q->param('email', $MAIL);

	$dc->q->param('GOLD', $row[$dc->UserOff('GOLD')]);
	$dc->q->param('SILVER', $row[$dc->UserOff('SILVER')]);
	$dc->q->param('BRONZE', $row[$dc->UserOff('BRONZE')]);
	$dc->q->param('BLUERIB', $row[$dc->UserOff('BLUERIB')]);

	$charIndex = $CharactersTbl[$Char]->[2];
				
	# Update user table information
	($errN, $errstr, @oldDATA) = DB::getRow_WRankByUKandEVENT( $dbh, $dc->DBaseTable('WRANK'), $UserKey, $EventID );
	if ($errN)
	{
		$dc->error("[score] Fetching WRank info: $errN .... $errstr", $errorURL);
	}
	
	if ($oldDATA[$dc->WRankOff('KEY')] ne $UserKey)
	{
		# New Record so go ahead and store it
		$newentry = 1;

		($errN, $errstr)       = DB::insertRow_WRank( $dbh, $dc->DBaseTable('WRANK'), $UserKey, $EventID, $Type, $Stage, $charIndex, $Rank, $Score, $dc->q->param('COMMENT'), time );
		if ($errN)
		{
			$dc->error("[score] Unable to create WRank info: $errN .... $errstr", $errorURL);
		}
	}
	else
	{
		# First need to see if the current time is better than the one already stored
		if ((($Type == 0) && ($oldDATA[$dc->WRankOff('SCORE')] < $Score)) ||	# Story Mode Point based so smaller is bad
			(($Type == 1) && ($oldDATA[$dc->WRankOff('SCORE')] > $Score)) ||	# Jet Crush Time based so larger is bad
			(($Type == 2) && ($oldDATA[$dc->WRankOff('SCORE')] < $Score)) ||	# Jet Technique Point based so smaller is bad
			(($Type == 3) && ($oldDATA[$dc->WRankOff('SCORE')] < $Score)))		# Jet Graffiti Point based so smaller is bad
		{
			# Renew Data for Time Attack
			$newentry = 1;

			# Modify existing record

			($errN, $errstr)       = DB::modifyRow_WRankByUKandEVENT( $dbh, $dc->DBaseTable('WRANK'), $UserKey, $EventID, $Type, $Stage, $charIndex, $Rank, $Score, $dc->q->param('COMMENT'), time );
			if ($errN)
			{
				$dc->error("[score] Unable to modify WRank info: $errN .... $errstr", $errorURL);
			}
		}
	}

	DB::closeOracleConnection( $dbh );


	return ($newentry);
}

#------------------------------------------------
# Determine what your ranking is
#------------------------------------------------
sub determine_rank {
	my $UserKey = shift;
	my $EventID = shift;
	my $type = shift;

	my ($dbh, $sth, $errN, $errstr, @row, $key, $adminkey);
	my $rank = 0;
	my $currank = 0;
	my $searchtime = 0;
					
	# Read user information from the table
	# Administration name uses completely unique and illegal characters so it can't be duplicated
	$adminkey = $dc->get_key($dc->DBaseTable('ADMIN'));
		
	($dbh, $errstr) = DB::openOracleConnection();
	if( !$dbh )
	{
		$dc->error("[admin_wrank] Error connecting to database: $errstr");
	}

	if ($type eq "TODAY")
	{
		$searchtime = (1*24*60*60);			# (24 hours in seconds)
	}
	else
	{
		# 5 Years in seconds
		$searchtime = (5*365*24*60*60);		# (5 Years in seconds)
	}

	if ($Type == 1)
	{
		# Jet Crush is time based and Ascending
		($errN, $errstr, $sth) = DB::getRow_WRankByEvent( $dbh, $dc->DBaseTable('WRANK'), $EventID, "ASC", $searchtime  );
		if ($errN)
		{
			$dc->error("[score] Unable to get Ascending Events: $errN .... $errstr", $errorURL);
		}
	}
	else
	{
		($errN, $errstr, $sth) = DB::getRow_WRankByEvent( $dbh, $dc->DBaseTable('WRANK'), $EventID, "DESC", $searchtime  );
		if ($errN)
		{
			$dc->error("[score] Unable to get Descending Events: $errN .... $errstr", $errorURL);
		}
	}

    while( (@row) = DB::getNextRow_WRank($sth) )
	{
		$key = $row[$dc->WRankOff('KEY')];
		if (($key ne "") && ($key ne $adminkey))
		{
			++$rank;
			if ($key eq $UserKey)
			{
				$currank = $rank;
			}
		}
	}

	DB::closeOracleConnection( $dbh );

	# Side effect is total number of records have been read
	$MaxRec = $rank;

	return ($currank);
}

#------------------------------------------------
# Decode
#------------------------------------------------
sub decode {
    my $srcdata = shift;

	my $errorNum = 0;
	my($offset, $ptr, $pos, $length, $initials, $temp, $loop, $i, $j, $k, @tempArr);

	if ($srcdata eq "")
	{
		$dc->error("[score] An error occurred while trying to repost your World Ranking data.  Please try uploading your World Ranking file again.", "rank.html");
	}

    # BASE64Decode
    @BINDATA = $dc->decode_base64($srcdata);

	##############################################################
	# Data structure decode begin
	my ($ptr, $offset);
	my ($guid, $volume, $gameclear);
	my (@rank_point, @rank_rank, @rank_player);
	
	$dc->decode_jgrData(0x280, \@BINDATA);
	
	
	$offset = 0x280;
			
	$ptr = 0;
	$guid = $BINDATA[$offset + $ptr] | ($BINDATA[$offset + $ptr + 1] << 8) | ($BINDATA[$offset + $ptr + 2] << 16) | ($BINDATA[$offset + $ptr + 3] << 24);
	$ptr += 4;
		
	###########################
	if($guid != 26060415) {
	$dc->error("[score] Checksum Error!<BR>World Ranking data is corrupted.", $errorURL);
	}
	
	###########################
	
	# Volume Level
	my @tempArr1 = ($BINDATA[$offset + $ptr], $BINDATA[$offset + $ptr + 1], $BINDATA[$offset + $ptr + 2], $BINDATA[$offset + $ptr + 3]);
	$volume = $dc->BinaryToFloat(\@tempArr1);
	$ptr += 4;
		
	# Unlocked objects
	$gameclear = $BINDATA[$offset + $ptr] | ($BINDATA[$offset + $ptr + 1] << 8) | ($BINDATA[$offset + $ptr + 2] << 16) | ($BINDATA[$offset + $ptr + 3] << 24);
	$ptr += 4;
		
	for ($i = 0; $i < (5 * 4); $i++)
	{
		for ($j = 0; $j < 5; $j++)
		{
			$rank_point[$i][$j] = $BINDATA[$offset + $ptr] | ($BINDATA[$offset + $ptr + 1] << 8) | ($BINDATA[$offset + $ptr + 2] << 16) | ($BINDATA[$offset + $ptr + 3] << 24);
			$ptr += 4;
			if (($i == 1) || ($i == 5) || ($i == 9) || ($i == 13) || ($i == 17))
			{
				$rank_point[$i][$j] = $rank_point[$i][$j] / 100.0;
			}
						
			$rank_rank[$i][$j] = $BINDATA[$offset + $ptr];
			$ptr += 1;
						
			$rank_player[$i][$j] = $BINDATA[$offset + $ptr];
			$ptr += 1;
						
			# Possible Padding
			$ptr += 1;
						
			# Possible Padding
			$ptr += 1;
		}
	}
			
			
	###########################
	# Get relavent information
	
	my $var;

	if ($Type == 0)
	{
		# Story Mode
		$var = ($Mode / 10);
	}
	else
	{
		$var = 0;
	}

	$Score = $rank_point[(($Stage * 4) + $Type)][$var];
	
	$Char = $rank_player[(($Stage * 4) + $Type)][$var];
	
	$Rank = $rank_rank[(($Stage * 4) + $Type)][$var];
	
	$dc->q->param("CharName", $CharactersTbl[$Char]->[0]);
	$dc->q->param("CharImg", $CharactersTbl[$Char]->[1]);
	
	$dc->q->param("RankName", $RankTbl[$Rank]->[0]);
	$dc->q->param("RankImg", $RankTbl[$Rank]->[1]);
	
	if ($Type == 1)
	{
		$dc->q->param('Score', $dc->CalcTime($Score));
	}
	else
	{
		$dc->q->param('Score', $Score);
	}
		
    return($errorNum);
}

#--------------------------------------------------------
# Result Output
#--------------------------------------------------------
sub output_verify {
	my $newRecord = shift;

    print "Content-type: text/html\n\n";
    print <<EOF;

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title>Jet Grind Radio - Upload Verification</title>
<meta name=x-uirequest content=nohscroll>
</head>

<body bgcolor=#E6CE00 x-marginleft=0 TEXT="#660000" LINK="#B96800" VLINK="#B96800" ALINK="#B96800" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0>



<center>
<TABLE WIDTH="550" BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<tr>
		<TD valign=top width=550><img src="/images/title_rankings.gif" width=550 height=46 border=0 alt=""></td>
	</tr>
</table>
<TABLE WIDTH="550" BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<tr>
		<TD width=7 valign=top><img src="/images/clear.gif" width=7 height=1 border=0 alt=""></td>
		<TD width=368 valign=top><br>
EOF

	print "<img src=\"".$dc->q->param('StageText')."\" width=320 height=30 border=0 alt=\"\"><br>\n";
	print "<img src=\"".$dc->q->param('StageImg')."\" width=320 height=120 border=0 alt=\"\"><br><br>\n";
	print "Mode: <b>".$dc->q->param('GameType')." ".$dc->q->param('LevelName')."</b>  <br><br>\n";

	if ($newRecord == 1)
	{
		print "Congratulations!<p>\n\n";

	}
	else
	{
		my $oldScore = $oldDATA[$dc->WRankOff('SCORE')];
		my $oldChar = hex($oldDATA[$dc->WRankOff('CHAR')]);
		my $oldRank = $oldDATA[$dc->WRankOff('RANK')];

		if ($Type == 1)
		{
			print "<FONT COLOR=\"RED\" SIZE=1>The new time of ".$dc->q->param('Score')." will not be recorded\n";
			print "because your previous time was faster.<P>\n";
			print "Here is your current record:</FONT><p>\n";

			$dc->q->param('Score', $dc->CalcTime($oldScore));
		}
		else
		{
			print "<FONT COLOR=\"RED\" SIZE=1>The new point total of ".$dc->q->param('Score')." will not be recorded\n";
			print "because your previous point total was higher.<P>\n";
			print "Here is your current record:</FONT><p>\n";

			$dc->q->param('Score', $oldScore);
		}


		$dc->q->param('CharImg', $CharactersTbl[$oldChar]->[1]);
		$dc->q->param('RankImg', $RankTbl[$oldRank]->[1]);
		$dc->q->param('COMMENT', $oldDATA[$dc->WRankOff('COMMENT')]);
	}

	print "You placed #$allrank in World Rankings!<br><BR>\n";
	print "You placed #$todayrank in Today's Rankings!<p>\n";


	##########################################3
	# Draw the output table

	print <<EOF;
			<table width=100% cellpadding=6 cellspacing=0 border=0>
				<tr>
<!--BEGIN RANK TABLE-->
EOF

	print "<td bgcolor=#cccccc valign=top rowspan=2>";

	if ($allrank == 1)
	{
		print "<img src=\"/images/wrank/can_gold.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
	}
	elsif ($allrank == 2)
	{
		print "<img src=\"/images/wrank/can_silver.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
	}
	elsif ($allrank == 3)
	{
		print "<img src=\"/images/wrank/can_bronze.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
	}
	elsif ($todayrank == 1)
	{
		print "<img src=\"/images/wrank/award_no1.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
	}
	elsif ($todayrank == 2)
	{
		print "<img src=\"/images/wrank/award_no2.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
	}
	elsif ($todayrank == 3)
	{
		print "<img src=\"/images/wrank/award_no3.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
	}

	print "</TD>\n";

	print "<td bgcolor=#cccccc valign=top>";
	print $dc->q->param('Score')."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	print "Rank:\n<BR>\n";
	print "<img src=\"".$dc->q->param('CharImg')."\" border=0 width=50 height=50>";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src=\"".$dc->q->param('RankImg')."\" border=0 width=81 height=50 align=top><br>\n";

	if ($dc->Flags($dc->q->param('COUNTRY')) ne "")
	{
		print "<img src=\"/images/flags/".$dc->Flags($dc->q->param('COUNTRY'))."\" width=40 height=20 border=0><BR>\n";	
	} else {
		# Draw the generic flag
		print "<img src=\"/images/flags/flag_other.gif\" width=40 height=20 border=0><BR>\n";
	}
	print $dc->q->param('NAME')."<br>\n";
	if ($dc->q->param('CITY') ne "")
	{
		# Don't bother printing the comma if no city is chosen
		print $dc->q->param('CITY').", ";
	}
	if (($dc->q->param('COUNTRY') eq "US") && ($dc->q->param('STATE') ne "")) {
		printf "%s, ", $dc->q->param('state');
	}
	printf "%s<br>\n", $dc->q->param('country');
	if($dc->q->param('MAIL') eq "Y") {
		print $dc->q->param('email')."<BR>\n";
	} else {
		print "E-Mail Hidden<BR>\n";
	}
	print "</td>\n";
	print "<td bgcolor=#cccccc valign=top>Awards:<br>";

	my $count = 0;
	my $loop;

	for ($loop = 0; $loop < $dc->q->param('GOLD'); ++$loop)
	{
		print "<img src=\"/images/wrank/can_sm_gold.gif\" width=17 height=35 border=0 hspace=2 align=\"top\">";
		++$count;
		if ($count >= 8)
		{
			print "<BR><img src=\"/images/clear.gif\" height=2 width=1 border=0><br>\n";
			$count = 0;
		}
	}

	for ($loop = 0; $loop < $dc->q->param('SILVER'); ++$loop)
	{
		print "<img src=\"/images/wrank/can_sm_silver.gif\" width=17 height=35 border=0 hspace=2 align=\"top\">";
		++$count;
		if ($count >= 8)
		{
			print "<BR><img src=\"/images/clear.gif\" height=2 width=1 border=0><br>\n";
			$count = 0;
		}
	}

	for ($loop = 0; $loop < $dc->q->param('BRONZE'); ++$loop)
	{
		print "<img src=\"/images/wrank/can_sm_bronze.gif\" width=17 height=35 border=0 hspace=2 align=\"top\">";
		++$count;
		if ($count >= 8)
		{
			print "<BR><img src=\"/images/clear.gif\" height=2 width=1 border=0><br>\n";
			$count = 0;
		}
	}

	for ($loop = 0; $loop < $dc->q->param('BLUERIB'); ++$loop)
	{
		print "<img src=\"/images/wrank/award_smglasses.gif\" width=25 height=25 border=0 hspace=2 align=\"top\">";
		++$count;
		if ($count >= 16)
		{
			print "<BR><img src=\"/images/clear.gif\" height=2 width=1 border=0><br>\n";
			$count = 0;
		}
	}

	print "\n</td></tr>\n";
	print "<TR><td bgcolor=#cccccc valign=top colspan=2>".$dc->q->param('COMMENT')."</td>\n";

########################

	print <<EOF;
				</tr>
			</table><br><br>
			
<a href="/rank.html"><img src="/images/button_back.gif" width=200 height=30 border=1 alt="" align=right></a><br><br></td>
		<TD width=175 valign=top><img src="/images/graphic_rankings.gif" width=175 height=400 border=0 alt=""></td>
	</tr>
</table>
</body>

</html>
EOF

}

######################################################################
# Display contents of World Rankings
######################################################################

#--------------------------------------------------------
# Data Check
#--------------------------------------------------------
sub check_search {
	my ($errN, $errstr, $dbh, $sth, @wrank);
	my ($Assort, $Stage, $Chara, $val);

	$dc->q->param('message', "You can search for rankings here. Search by Email or go through the ranks.  ");

	if($IN::max ne "") {
		$MAX = $IN::max;
		if($MAX<=0) {
			# Set default maximum size
			$MAX=10;
		}
	}
		
	$START=0;
	if($IN::start ne "") {
		$START = ($IN::start - 1);
		if($START<0) {
			$START=0;
		}
	}

	# Save original Maximum Record Score
	my $OldMax = $MaxRec;

	# Determine total number of records for All time and Today
	&determine_rank("", $EventID, "ALL");
	$dc->q->param("maxall", $MaxRec);
	&determine_rank("", $EventID, "TODAY");
	$dc->q->param("maxtoday", $MaxRec);

	# Restore original Maximum Records Score
	$MaxRec = $OldMax;

	#Initialize base values
	$dc->q->param('max', $MAX);
	$dc->q->param('start', $START + 1);

	if ($IN::type eq "TODAY") {
		$type = "TODAY";
	} else {
		$type = "ALL";
		$dc->q->param('type', "ALL");
	}
		
	if($IN::mailid ne "") {
		$UserKey = $dc->get_key($IN::mailid);
		if ($UserKey eq "")
		{
			$dc->q->param('message', "<font color=\"#ff0000\">Sorry, no matches were found containing <b>$IN::mailid</b>.</font><p>Please try again. ");
		
			# Terminate the search
			$dc->output_form("html/rank_search.html");
			undef($UserKey);
			exit(0);
		}
		else
		{
			($dbh, $errstr) = DB::openOracleConnection();
			if( !$dbh )
			{
				$dc->error("[score] Error connecting to database: $errstr", $errorURL);
			}

		    ($errN, $errstr, @wrank) = DB::getRow_WRankByUKandEVENT( $dbh, $dc->DBaseTable('WRANK'), $UserKey, $EventID );
			if ($errN)
			{
				$dc->error("[score] Fetching user info: $errN .... $errstr", $errorURL);
			}

			DB::closeOracleConnection( $dbh );

			if (($wrank[$dc->WRankOff('KEY')] ne $UserKey))
			{
				$dc->q->param('message', "<font color=\"#ff0000\">Sorry, no matches were found containing <b>$IN::mailid</b>.</font><p>Please try again. ");

				# Terminate the search
				$dc->output_form("html/rank_search.html");
				undef($UserKey);
				exit(0);
			}
		}
	}
}

#--------------------------------------------------------
# Read Key Data
#--------------------------------------------------------
sub read_data {
	my $key = shift;
	my ($errN, $errstr, $dbh, $sth, @row);

	($dbh, $errstr) = DB::openOracleConnection();
	if( !$dbh )
	{
		$dc->error("[score] Error connecting to database: $errstr", $errorURL);
	}

	if($UserKey eq "") {
		# Calculate the maximum number of records
		&determine_rank("", $EventID, $dc->q->param('type'));

		if($START < $MaxRec) {
			if(($MaxRec-$START)>($MAX)) {
				$END=$START+$MAX;
				$nextflag=0; 
			} else {
				$END=$MaxRec;
				$nextflag=1;
			}
		}
	}

	return $dbh;
}

#--------------------------------------------------------
# HTML Output
#--------------------------------------------------------
sub output_records {
	my $dbh = shift;

	my ($errN, $errstr, $sth, @user, @wrank);
	my $loop = 0;
	my $adminkey = $dc->get_key($dc->DBaseTable('ADMIN'));
	my $AdxFile = $dc->q->param('AdxFile');
	my $searchtime = 0;

    print "Content-type: text/html\n";
    print <<EOF;

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title>Jet Grind Radio</title>
<meta name=x-uirequest content=nohscroll>
</head>

<body bgcolor=#E6CE00 x-marginleft=0 TEXT="#660000" LINK="#B96800" VLINK="#B96800" ALINK="#B96800" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0>


<center>

<TABLE WIDTH="550" BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<tr>
		<TD valign=top width=550><img src="/images/title_rankings.gif" width=550 height=46 border=0 alt=""></td>
	</tr>
</table>
<TABLE WIDTH="550" BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<tr>
		<TD width=7 valign=top><img src="/images/clear.gif" width=7 height=1 border=0 alt=""></td>
		<TD width=368 valign=top>
EOF

	print "<img src=\"".$dc->q->param('StageText')."\" width=320 height=30 border=0 alt=\"\"><br>\n";
	print "<b>".$dc->q->param('GameType')." ".$dc->q->param('LevelName')."</b><br><br>\n";

	print <<EOF;
		<center>
EOF

	if ($UserKey eq "")
	{
		&output_link;
	}

	print "<br>";
	
	if ($dc->q->param('type') eq "TODAY")
	{
		$searchtime = (7*24*60*60);
	}
	else
	{
		# 5 Years in seconds
		$searchtime = (5*365*24*60*60);
	}

	if ($Type == 1)
	{
		# Jet Crush is time based and Ascending
		($errN, $errstr, $sth) = DB::getRow_WRankByEvent( $dbh, $dc->DBaseTable('WRANK'), $EventID, "ASC", $searchtime  );
		if ($errN)
		{
			$dc->error("[score] Unable to get Ascending Events: $errN .... $errstr", $errorURL);
		}
	}
	else
	{
		($errN, $errstr, $sth) = DB::getRow_WRankByEvent( $dbh, $dc->DBaseTable('WRANK'), $EventID, "DESC", $searchtime  );
		if ($errN)
		{
			$dc->error("[score] Unable to get Descending Events: $errN .... $errstr", $errorURL);
		}
	}


	if($UserKey ne "") {
		my $Rank = 0;
	    while( (@wrank) = DB::getNextRow_WRank($sth) )
		{
			if ($wrank[$dc->WRankOff('KEY')] eq $adminkey)
			{
				#Skip that record since it is the Admin record
				(@wrank) = DB::getNextRow_WRank($sth);
			}

			if ($wrank[$dc->WRankOff('KEY')] eq $UserKey)
			{
				($errN, $errstr, @user) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $UserKey );
				if ($errN)
				{
					$dc->error("[score] Fetching user info: $errN .... $errstr", $errorURL);
				}
				&build_table($Rank, \@user, \@wrank);
			}
			++$Rank;
		}
	} else {
		for($loop=0;$loop<$END;$loop++) {
			(@wrank) = DB::getNextRow_WRank($sth);
			if ($wrank[$dc->WRankOff('KEY')] eq $adminkey)
			{
				#Skip that record since it is the Admin record
				(@wrank) = DB::getNextRow_WRank($sth);
			}
			if ($loop >= $START)
			{
				($errN, $errstr, @user) = DB::getRow_UserByUK( $dbh, $dc->DBaseTable('USER'), $wrank[$dc->WRankOff('KEY')] );
				if ($errN)
				{
					$dc->error("[score] Fetching user info: $errN .... $errstr", $errorURL);
				}
				&build_table($loop, \@user, \@wrank);
			}
		}
	}

	DB::closeOracleConnection( $dbh );

	if ($UserKey eq "")
	{
		&output_link;
	}

    print <<EOF;
<!-- end of content -->
		<br><br>


<a href="JAVASCRIPT:history.back();"><img src="/images/button_back.gif" width=200 height=30 border=1 alt="" align=right></a><br><br></td>
		<TD width=175 valign=top><img src="/images/graphic_rankings.gif" width=175 height=400 border=0 alt=""><br><br></td>
	</tr>
</table>
</body>

</html>
EOF

}

sub build_table {
	my $rank = shift;
	my $user = shift;
	my $wrank = shift;

	print <<EOF;
			<table width=365 cellpadding=6 cellspacing=0 border=0>
				<tr>
<!--BEGIN RANK TABLE-->
EOF

	print "<td width=45 bgcolor=#cccccc valign=top rowspan=2>";
	printf "#%d<BR>",$rank+1;

	if ($dc->q->param('type') eq "TODAY")
	{
		if ($rank == 0)
		{
			print "<img src=\"/images/wrank/award_no1.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
		}
		elsif ($rank == 1)
		{
			print "<img src=\"/images/wrank/award_no2.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
		}
		elsif ($rank == 2)
		{
			print "<img src=\"/images/wrank/award_no3.gif\" width=33 height=70 border=0 hspace=5 align=\"top\">";
		}
	}
	else
	{
		if ($rank == 0)
		{
			print "<img src=\"/images/wrank/can_gold.gif\" width=33 height=70 border=0 hspace=5>";
		}
		elsif ($rank == 1)
		{
			print "<img src=\"/images/wrank/can_silver.gif\" width=33 height=70 border=0 hspace=5>";
		}
		elsif ($rank == 2)
		{
			print "<img src=\"/images/wrank/can_bronze.gif\" width=33 height=70 border=0 hspace=5>";
		}
	}
	print "</TD>\n";

	print "<td width=220 bgcolor=#cccccc valign=top>";
	print "<table cellpadding=0 cellspacing=0 border=0>\n";      
   	print "<TR><TD width=104>".$wrank->[$dc->WRankOff('SCORE')]."</TD><TD width=104>";
	print "Rank:</TD></TR>\n";
	# Convert character from hexadecimal to integer
	my $index = hex($wrank->[$dc->WRankOff('CHAR')]);
	print "<TR><TD><img src=\"".$CharactersTbl[$index]->[1]."\" border=0 width=100 height=50></TD>";
	print "<TD><img src=\"".$RankTbl[($wrank->[$dc->WRankOff('RANK')])]->[1]."\" border=0 width=81 height=50 align=top></TD>\n";
	print "</TR></TABLE>\n";

	if ($dc->Flags($user->[$dc->UserOff('COUNTRY')]) ne "")
	{
		print "<img src=\"/images/flags/".$dc->Flags($user->[$dc->UserOff('COUNTRY')])."\" width=40 height=20 border=0><BR>\n";	
	} else {
		# Draw the generic flag
		print "<img src=\"/images/flags/flag_other.gif\" width=40 height=20 border=0><BR>\n";
	}
	print "$user->[$dc->UserOff('NAME')]<br>\n";
	if ($user->[$dc->UserOff('CITY')] ne "")
	{
		print $user->[$dc->UserOff('CITY')].", ";
	}
	if (($user->[$dc->UserOff('COUNTRY')] eq "US") && ($user->[$dc->UserOff('STATE')] ne ""))
	{
		printf "%s,<BR>", $dc->state_name($user->[$dc->UserOff('STATE')]);
	}
	printf " %s<br>\n", $dc->country_name($user->[$dc->UserOff('COUNTRY')]);
	if($user->[$dc->UserOff('MFLAG')] eq "Y") {
		print "<A HREF=\"mailto:$user->[$dc->UserOff('EMAIL')]\"><IMG src=\"/images/button_email.gif\" width=72 height=14 border=0></A><BR>\n";
	} else {
		print "<BR>\n";
	}
	print "</td>\n";
	print "<td width=100 bgcolor=#cccccc valign=top>Awards:<br>";

	my $count = 0;
	my $loop;

	for ($loop = 0; $loop < $user->[$dc->UserOff('GOLD')]; ++$loop)
	{
		print "<img src=\"/images/wrank/can_sm_gold.gif\" width=17 height=35 border=0 hspace=2 align=\"top\">";
		++$count;
		if ($count >= 8)
		{
			print "<BR><img src=\"/images/clear.gif\" height=2 width=1 border=0><br>\n";
			$count = 0;
		}
	}

	for ($loop = 0; $loop < $user->[$dc->UserOff('SILVER')]; ++$loop)
	{
		print "<img src=\"/images/wrank/can_sm_silver.gif\" width=17 height=35 border=0 hspace=2 align=\"top\">";
		++$count;
		if ($count >= 8)
		{
			print "<BR><img src=\"/images/clear.gif\" height=2 width=1 border=0><br>\n";
			$count = 0;
		}
	}

	for ($loop = 0; $loop < $user->[$dc->UserOff('BRONZE')]; ++$loop)
	{
		print "<img src=\"/images/wrank/can_sm_bronze.gif\" width=17 height=35 border=0 hspace=2 align=\"top\">";
		++$count;
		if ($count >= 8)
		{
			print "<BR><img src=\"/images/clear.gif\" height=2 width=1 border=0><br>\n";
			$count = 0;
		}
	}

	for ($loop = 0; $loop < $user->[$dc->UserOff('BLUERIB')]; ++$loop)
	{
		print "<img src=\"/images/wrank/award_smglasses.gif\" width=25 height=25 border=0 hspace=2 align=\"top\">";
		++$count;
		if ($count >= 16)
		{
			print "<BR><img src=\"/images/clear.gif\" height=2 width=1 border=0><br>\n";
			$count = 0;
		}
	}

	print "\n</td></tr>\n";
	print "<TR><td width=320 bgcolor=#cccccc valign=top colspan=2>".$wrank->[$dc->WRankOff('COMMENT')]."<BR></td>\n";

	print <<EOF;
		</tr>
	</table><br>
<!--END RANK TABLE-->	
EOF
}

sub output_link {
	# Link Menu Output
	my $str = "";
	my $prank = 0;
	my $nrank = 0;
		
	if($START > 0) {
		$prank=$START-$MAX+1;
		if($prank<0) { $prank=0; }
		$str= 'command=view&max=' . $MAX . '&start=' . $prank .
              '&STAGE='.$dc->q->param('STAGE') . '&MODE='.$dc->q->param('MODE') . '&type='. $dc->q->param('type');
		print "<a href=\"$cgiPath?$str\"><img src=\"/images/button_prev.gif\" width=70 height=14 border=0 alt=\"\"></a>";
	}
	else
	{
		print "<img src=\"/images/clear.gif\" width=70 height=14 border=0 alt=\"\">";
	}

	print "<img src=\"/images/clear.gif\" width=210 height=14 border=0 alt=\"\">";
	if($nextflag==0) {
		$nrank=$START+$MAX+1;
		$str= 'command=view&max=' . $MAX . '&start=' . $nrank .
              '&STAGE='.$dc->q->param('STAGE') . '&MODE='.$dc->q->param('MODE') . '&type='. $dc->q->param('type');
		print "<a href=\"$cgiPath?$str\"><img src=\"/images/button_next.gif\" width=70 height=14 border=0 alt=\"\"></a>";
	}
	else
	{
		print "<img src=\"/images/clear.gif\" width=70 height=14 border=0 alt=\"\"></a>";
	}
}

#------------------------ EOF --------------------------
