#!/usr/bin/perl -I.
# Dreamcast Version
# Rush 2049
# Ghost Race Download Data
# 


use strict;

use CGI;
use	DC;
use DB;


## Set up variables
use vars	(	'$dc',	# DC object
				'@IN',
				'$GHOST',
				'$scorecgiPath',
				'$errorURL',
				'$vmsurl',
				'$vmsdir',
				'$browserid',
			);

#...............................................

	my $q = new CGI;
	$dc = new DC($q);
	$dc->q->import_names('IN');
	$browserid = -1;

	$errorURL = "world_rankings.html";
	$scorecgiPath = "/cgi-bin/rush2049/score.cgi";
	$vmsurl = 'http://rush2049.web.dreamcast.com/tmp';
	$vmsdir = '/web/rush2049.web/tmp';
	my $fileid = sprintf "%06d", $$;
	my $newname1 = substr($IN::filename, 0, (length($IN::filename) - 1))."A";
	my $newname2 = substr($IN::filename, 0, (length($IN::filename) - 1))."B";
	my $newname3 = substr($IN::filename, 0, (length($IN::filename) - 1))."C";

	my ($errN, $errstr, $dbh, $sth, @row);

    &check_data;

	($dbh, $errstr) = DB::openOracleConnection();
	if( !$dbh )
	{
		$dc->error("[getghost] Error connecting to database: $errstr", $errorURL);
	}

    ($errN, $errstr, @row) = DB::getRow_WRankByUKandEVENT( $dbh, $dc->DBaseTable('WRANK'), $IN::UserKey, $IN::EventID );
	if ($errN)
	{
		$dc->error("[getghost] Fetching Ghost info: $errN .... $errstr", $errorURL);
	}
	if (@row eq "")
	{
		$dc->error("[getghost] User key does not exist", $errorURL);
	}

	# Update the Download Count
	($errN, $errstr)       = DB::modifyRow_WRankByUKandEVENT( $dbh, $dc->DBaseTable('WRANK'), $IN::UserKey, $IN::EventID, $row[$dc->WRankOff('COURSE')], $row[$dc->WRankOff('CARTYPE')], $row[$dc->WRankOff('MIRROR')], $row[$dc->WRankOff('TIMEC')], $row[$dc->WRankOff('COMMENT')], $row[$dc->WRankOff('INVALID')], $row[$dc->WRankOff('ULCOUNT')], ($row[$dc->WRankOff('DLCOUNT')] + 1), $row[$dc->WRankOff('CURRANK')], $row[$dc->WRankOff('MDATE')], $row[$dc->WRankOff('VMS')] );
	if ($errN)
	{
		$dc->error("[getghost] Updating Download Count: $errN .... $errstr", $errorURL);
	}

	DB::closeOracleConnection( $dbh );

	make_vmsfile($fileid."_A", $row[$dc->WRankOff('VMS')], $newname1);
	make_vmsfile($fileid."_B", $row[$dc->WRankOff('VMS')], $newname2);
	make_vmsfile($fileid."_C", $row[$dc->WRankOff('VMS')], $newname3);

	$dc->q->param('fileA', "${vmsurl}/${fileid}_A.VMI");
	$dc->q->param('fileB', "${vmsurl}/${fileid}_B.VMI");
	$dc->q->param('fileC', "${vmsurl}/${fileid}_C.VMI");

	my $str= 'command='.$IN::command.'&max='. $IN::MAX .'&start='.$IN::start.'&ASSORT='.$IN::ASSORT.
              '&TRACK='.$IN::TRACK.'&MODE='.$IN::MODE.'&type='.$IN::type;
	$dc->q->param('BACK', "$scorecgiPath?$str");

    # Display Ghost Data Options
	$dc->output_form("html/rank_ghost_select.html");

exit(0);

#--------------------------------------------------------
# Data Check
#--------------------------------------------------------
sub check_data {
    if($IN::UserKey eq "") {
        $dc->error("[getghost] Invalid user key was given \"$IN::UserKey\".", $errorURL);
    }

	if ($dc->q->referer() !~ m(^http://rush2049\.web\.dreamcast\.com/))
	{
		$dc->error("[getghost] File request denied.<BR>Only authorized URLs allowed.", $errorURL);
	}

	$browserid = $dc->get_browser();
	if ($browserid == -1)
	{
		$dc->error("[getghost] File request denied.<BR>Only authorized browsers allowed.", $errorURL);
	}
}

#--------------------------------------------------------
# Cancel Unnecessary VMS Files
#--------------------------------------------------------
sub del_vmsfile {
	my $filename = shift;

	unlink("${vmsdir}/${filename}.VMI");
	unlink("${vmsdir}/${filename}.VMS");
}

#--------------------------------------------------------
# Create the VMS files for download
#--------------------------------------------------------
sub make_vmsfile {
	my $filename = shift;
	my $GHOST = shift;
	my $VMUNAME = shift;

	# Clear out old VMS and VMI files sitting on the system
	&del_vmsfile($filename);

	# Create the VMS file
    if(open(VMSFILE,">${vmsdir}/${filename}.VMS")) {
        print VMSFILE $GHOST;
        close(VMSFILE);
        chmod(0666,"${vmsdir}/${filename}.VMS");
    } else {
        $dc->error("[getghost] Failure to create VMS file \"${filename}\".", $errorURL);
    }

	# Create the VMI file
    if(open(VMIFILE,">${vmsdir}/${filename}.VMI")) {
		my $vmidata = "";

        $vmidata = $dc->make_vmidata($filename, length($GHOST), $VMUNAME);
        print VMIFILE $vmidata;

        close(VMIFILE);
        chmod(0666,"${vmsdir}/${filename}.VMI");
    } else {
        $dc->error("[getghost] Failure to create VMI file \"${filename}\".", $errorURL);
    }

}

#------------------------ EOF --------------------------

